package fr.itsee.season;

import android.app.AlertDialog;
import android.app.Dialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.SharedPreferences;
import android.content.pm.ActivityInfo;
import android.content.res.AssetFileDescriptor;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.media.MediaPlayer;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Handler;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.DefaultItemAnimator;
import android.support.v7.widget.DividerItemDecoration;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.text.method.ScrollingMovementMethod;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;
import com.symbol.emdk.EMDKManager;
import com.symbol.emdk.EMDKManager.EMDKListener;
import com.symbol.emdk.EMDKManager.FEATURE_TYPE;
import com.symbol.emdk.EMDKResults;
import com.symbol.emdk.barcode.BarcodeManager;
import com.symbol.emdk.barcode.BarcodeManager.ConnectionState;
import com.symbol.emdk.barcode.BarcodeManager.ScannerConnectionListener;
import com.symbol.emdk.barcode.ScanDataCollection;
import com.symbol.emdk.barcode.Scanner;
import com.symbol.emdk.barcode.Scanner.DataListener;
import com.symbol.emdk.barcode.Scanner.StatusListener;
import com.symbol.emdk.barcode.Scanner.TriggerType;
import com.symbol.emdk.barcode.ScannerConfig;
import com.symbol.emdk.barcode.ScannerException;
import com.symbol.emdk.barcode.ScannerInfo;
import com.symbol.emdk.barcode.ScannerResults;
import com.symbol.emdk.barcode.StatusData;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

public class ColisActivity extends AppCompatActivity implements EMDKListener, DataListener, StatusListener, ScannerConnectionListener, CompoundButton.OnCheckedChangeListener {
    //public class ColisActivity extends AppCompatActivity {

    private RecyclerView recyclerView;
    private ColisAdapter mAdapter;

    private Button rafraichirColis;

    private Colis colis;
    public static List<Colis> currentListeAScanner;

    private List<Colis> listeVide;

    private String dernierCodeColis;
    private int dernierColisEnvoye;

    //Partie Scanner

    private EMDKManager emdkManager = null;
    private BarcodeManager barcodeManager = null;
    private Scanner scanner = null;

    private TextView textViewData = null;
    private TextView textViewStatus = null;

    private CheckBox checkBoxEAN8 = null;
    private CheckBox checkBoxEAN13= null;
    private CheckBox checkBoxCode39= null;
    private CheckBox checkBoxCode128= null;

    private Spinner spinnerScannerDevices= null;

    private List<ScannerInfo> deviceList = null;

    private int scannerIndex = 0; // Keep the selected scanner
    private int defaultIndex = 0; // Keep the default scanner
    private String statusString = "";

    private boolean bSoftTriggerSelected = false;
    private boolean bDecoderSettingsChanged = false;
    private boolean bExtScannerDisconnected = false;
    private final Object lock = new Object();

    private String code128;

    //Son
    private MediaPlayer mediaPlayer;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_livraison);

        mAdapter = new ColisAdapter(new ArrayList<Colis>(), getApplicationContext());

        listeVide = new ArrayList<>();

        getListeColis();

        rafraichirColis = findViewById(R.id.rafraichirColis);
        //Permet de saisir manuellement les informations
        rafraichirColis.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                rafraichirLivraison();
            }
        });

        recyclerView = findViewById(R.id.recycler_view);
        textViewData = findViewById(R.id.textViewData);
        textViewStatus = findViewById(R.id.textViewStatus);
        checkBoxEAN8 = findViewById(R.id.checkBoxEAN8);
        checkBoxEAN13 = findViewById(R.id.checkBoxEAN13);
        checkBoxCode39 = findViewById(R.id.checkBoxCode39);
        checkBoxCode128 = findViewById(R.id.checkBoxCode128);
        spinnerScannerDevices = findViewById(R.id.spinnerScannerDevices);


        RecyclerView.LayoutManager mLayoutManager = new LinearLayoutManager(getApplicationContext());
        recyclerView.setLayoutManager(mLayoutManager);
        recyclerView.setItemAnimator(new DefaultItemAnimator());
        recyclerView.addItemDecoration(new DividerItemDecoration(this, LinearLayoutManager.VERTICAL));
        recyclerView.setAdapter(mAdapter);

        mAdapter.setOnItemClickListener(new ColisAdapter.OnItemClickListener() {
            @Override
            public void onSupprClick(int position) {
                dernierCodeColis = currentListeAScanner.get(position).getCodeColis();
                currentListeAScanner.get(position).setEnvoye(1);
                dernierColisEnvoye = currentListeAScanner.get(position).getEnvoye();

                new UpdateColisAsyncTask().execute();
                //Supprime de la liste le colis
                delColis(currentListeAScanner.get(position));

                //ICI, CI-DESSOUS permet de passer en vert la ligne du colis
                /*currentListeAScanner.get(position).setPret(1);
                mAdapter.notifyDataSetChanged();
                afficheColis();*/
            }
        });

        new GetListeColisAsyncTask().execute();

        deviceList = new ArrayList<ScannerInfo>();

        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_NOSENSOR);

        EMDKResults results = EMDKManager.getEMDKManager(getApplicationContext(), this);
        if (results.statusCode != EMDKResults.STATUS_CODE.SUCCESS) {
            updateStatus("EMDKManager object request failed!");
            return;
        }

        checkBoxEAN8.setOnCheckedChangeListener(this);
        checkBoxEAN13.setOnCheckedChangeListener(this);
        checkBoxCode39.setOnCheckedChangeListener(this);
        checkBoxCode128.setOnCheckedChangeListener(this);

        addSpinnerScannerDevicesListener();

        textViewData.setSelected(true);
        textViewData.setMovementMethod(new ScrollingMovementMethod());

    }

    @Override
    protected void onStop() {
        super.onStop();
        saveListeColis();
    }


    public void saveListeColis(){
        SharedPreferences sharedPreferences = this.getSharedPreferences("PREFS", Context.MODE_PRIVATE);
        Gson gson = new Gson();
        sharedPreferences.edit().putString("listeColis",gson.toJson(currentListeAScanner)).apply();
    }

    public void getListeColis(){
        SharedPreferences sharedPreferences = this.getSharedPreferences("PREFS", Context.MODE_PRIVATE);
        Gson gson = new Gson();

        String json = sharedPreferences.getString("listeColis",null);

        if(json != null){
            currentListeAScanner = gson.fromJson(json,new TypeToken<List<Colis>>() {}.getType());
        }
    }

    public void afficheColis(){
        if (currentListeAScanner != null){
            mAdapter.setListeColis(currentListeAScanner);
        } else {
            mAdapter.setListeColis(listeVide);
        }
        mAdapter.notifyDataSetChanged();
    }

    public void afficheVide(){
        mAdapter.setListeColis(listeVide);
        mAdapter.notifyDataSetChanged();
    }


    @Override
    public void onOpened(EMDKManager emdkManager) {
        updateStatus("EMDK open success!");
        this.emdkManager = emdkManager;
        // Acquire the barcode manager resources
        initBarcodeManager();
        // Enumerate scanner devices
        enumerateScannerDevices();
        // Set default scanner
        spinnerScannerDevices.setSelection(defaultIndex);
    }

    @Override
    protected void onResume() {
        super.onResume();
        new GetListeColisAsyncTask().execute();
        // The application is in foreground
        if (emdkManager != null) {
            // Acquire the barcode manager resources
            initBarcodeManager();
            // Enumerate scanner devices
            enumerateScannerDevices();
            // Set selected scanner
            spinnerScannerDevices.setSelection(scannerIndex);
            // Initialize scanner
            initScanner();
        }
    }

    @Override
    protected void onPause() {
        super.onPause();
        // The application is in background
        // Release the barcode manager resources
        deInitScanner();
        deInitBarcodeManager();
    }

    @Override
    public void onClosed() {
        // Release all the resources
        if (emdkManager != null) {
            emdkManager.release();
            emdkManager = null;
        }
        updateStatus("EMDK closed unexpectedly! Please close and restart the application.");
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        saveListeColis();
//         Release all the resources
        if (emdkManager != null) {
            emdkManager.release();
            emdkManager = null;
        }
    }

    @Override
    public void onData(ScanDataCollection scanDataCollection) {
        if ((scanDataCollection != null) && (scanDataCollection.getResult() == ScannerResults.SUCCESS)) {
            ArrayList <ScanDataCollection.ScanData> scanData = scanDataCollection.getScanData();
            for(ScanDataCollection.ScanData data : scanData) {
                updateData(data.getData());
            }
        }
    }

    @Override
    public void onStatus(StatusData statusData) {
        StatusData.ScannerStates state = statusData.getState();
        switch(state) {
            case IDLE:
                statusString = statusData.getFriendlyName()+" is enabled and idle...";
                updateStatus(statusString);
                // set trigger type
                if(bSoftTriggerSelected) {
                    scanner.triggerType = TriggerType.SOFT_ONCE;
                    bSoftTriggerSelected = false;
                } else {
                    scanner.triggerType = TriggerType.HARD;
                }
                // set decoders
                if(bDecoderSettingsChanged) {
                    setDecoders();
                    bDecoderSettingsChanged = false;
                }
                // submit read
                if(!scanner.isReadPending() && !bExtScannerDisconnected) {
                    try {
                        scanner.read();
                    } catch (ScannerException e) {
                        updateStatus(e.getMessage());
                    }
                }
                break;
            case WAITING:
                statusString = "Scanner is waiting for trigger press...";
                updateStatus(statusString);
                break;
            case SCANNING:
                statusString = "Scanning...";
                updateStatus(statusString);
                break;
            case DISABLED:
                statusString = statusData.getFriendlyName()+" is disabled.";
                updateStatus(statusString);
                break;
            case ERROR:
                statusString = "An error has occurred.";
                updateStatus(statusString);
                break;
            default:
                break;
        }
    }

    @Override
    public void onConnectionChange(ScannerInfo scannerInfo, ConnectionState connectionState) {
        String status;
        String scannerName = "";
        String statusExtScanner = connectionState.toString();
        String scannerNameExtScanner = scannerInfo.getFriendlyName();
        if (deviceList.size() != 0) {
            scannerName = deviceList.get(scannerIndex).getFriendlyName();
        }
        if (scannerName.equalsIgnoreCase(scannerNameExtScanner)) {
            switch(connectionState) {
                case CONNECTED:
                    bSoftTriggerSelected = false;
                    synchronized (lock) {
                        initScanner();
                        bExtScannerDisconnected = false;
                    }
                    break;
                case DISCONNECTED:
                    bExtScannerDisconnected = true;
                    synchronized (lock) {
                        deInitScanner();
                    }
                    break;
            }
            status = scannerNameExtScanner + ":" + statusExtScanner;
            updateStatus(status);
        }
        else {
            bExtScannerDisconnected = false;
            status =  statusString + " " + scannerNameExtScanner + ":" + statusExtScanner;
            updateStatus(status);
        }
    }

    private void initScanner() {
        if (scanner == null) {
            if ((deviceList != null) && (deviceList.size() != 0)) {
                if (barcodeManager != null)
                    scanner = barcodeManager.getDevice(deviceList.get(scannerIndex));
            }
            else {
                updateStatus("Failed to get the specified scanner device! Please close and restart the application.");
                return;
            }
            if (scanner != null) {
                scanner.addDataListener(this);
                scanner.addStatusListener(this);
                try {
                    scanner.enable();
                } catch (ScannerException e) {
                    updateStatus(e.getMessage());
                    deInitScanner();
                }
            }else{
                updateStatus("Failed to initialize the scanner device.");
            }
        }
    }

    private void deInitScanner() {
        if (scanner != null) {
            try{
                scanner.disable();
            } catch (Exception e) {
                updateStatus(e.getMessage());
            }

            try {
                scanner.removeDataListener(this);
                scanner.removeStatusListener(this);
            } catch (Exception e) {
                updateStatus(e.getMessage());
            }

            try{
                scanner.release();
            } catch (Exception e) {
                updateStatus(e.getMessage());
            }
            scanner = null;
        }
    }

    private void initBarcodeManager(){
        barcodeManager = (BarcodeManager) emdkManager.getInstance(FEATURE_TYPE.BARCODE);
        // Add connection listener
        if (barcodeManager != null) {
            barcodeManager.addConnectionListener(this);
        }
    }

    private void deInitBarcodeManager(){
        if (emdkManager != null) {
            emdkManager.release(FEATURE_TYPE.BARCODE);
        }
    }


    private void addSpinnerScannerDevicesListener() {
        spinnerScannerDevices.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View arg1, int position, long arg3) {
                if ((scannerIndex != position) || (scanner==null)) {
                    scannerIndex = position;
                    bSoftTriggerSelected = false;
                    bExtScannerDisconnected = false;
                    deInitScanner();
                    initScanner();
                }
            }
            @Override
            public void onNothingSelected(AdapterView<?> arg0) {
            }
        });
    }

    private void enumerateScannerDevices() {
        if (barcodeManager != null) {
            List<String> friendlyNameList = new ArrayList<String>();
            int spinnerIndex = 0;
            deviceList = barcodeManager.getSupportedDevicesInfo();
            if ((deviceList != null) && (deviceList.size() != 0)) {
                Iterator<ScannerInfo> it = deviceList.iterator();
                while(it.hasNext()) {
                    ScannerInfo scnInfo = it.next();
                    friendlyNameList.add(scnInfo.getFriendlyName());
                    if(scnInfo.isDefaultScanner()) {
                        defaultIndex = spinnerIndex;
                    }
                    ++spinnerIndex;
                }
            }
            else {
                updateStatus("Failed to get the list of supported scanner devices! Please close and restart the application.");
            }
            ArrayAdapter<String> spinnerAdapter = new ArrayAdapter<String>(ColisActivity.this, android.R.layout.simple_spinner_item, friendlyNameList);
            spinnerAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
            spinnerScannerDevices.setAdapter(spinnerAdapter);
        }
    }

    private void setDecoders() {
        if (scanner != null) {
            try {
                ScannerConfig config = scanner.getConfig();
                // Set EAN8
                config.decoderParams.ean8.enabled = checkBoxEAN8.isChecked();
                // Set EAN13
                config.decoderParams.ean13.enabled = checkBoxEAN13.isChecked();
                // Set Code39
                config.decoderParams.code39.enabled = checkBoxCode39.isChecked();
                //Set Code128
                config.decoderParams.code128.enabled = checkBoxCode128.isChecked();
                //QR CODE
                config.decoderParams.qrCode.enabled = true;
                scanner.setConfig(config);
            } catch (ScannerException e) {
                updateStatus(e.getMessage());
            }
        }
    }

    public void softScan(View view) {
        bSoftTriggerSelected = true;
        cancelRead();
    }

    private void cancelRead(){
        if (scanner != null) {
            if (scanner.isReadPending()) {
                try {
                    scanner.cancelRead();
                } catch (ScannerException e) {
                    updateStatus(e.getMessage());
                }
            }
        }
    }

    private void updateStatus(final String status){
        runOnUiThread(new Runnable() {
            @Override
            public void run() {
                textViewStatus.setText("" + status);
            }
        });
    }

    private void updateData(final String result){
        runOnUiThread(new Runnable() {
            @Override
            public void run() {
                if (result != null) {
                    if (currentListeAScanner == null){
                        new GetListeColisAsyncTask().execute();
                    }
                    else{
                        produitScanner(result);
                    }
                }
            }
        });
    }


    public int getColisPos(String result){
        int cpt = 0;
        for (Colis c : currentListeAScanner){
            if (c.getCodeColis().equals(result)){
                return cpt;
            }
            cpt += 1;
        }
        return cpt;
    }


    public void vider(){
        currentListeAScanner = null;
        mAdapter.setListeColis(currentListeAScanner);
        afficheVide();
    }

    public void rafraichirLivraison(){
        if (isAllScanned()){
            new GetListeColisAsyncTask().execute();
        }else if (currentListeAScanner != null){
            DialogInterface.OnClickListener dialogClickListener = new DialogInterface.OnClickListener() {
                @Override
                public void onClick(DialogInterface dialog, int which) {
                    switch (which){
                        case DialogInterface.BUTTON_POSITIVE:
                            dialog.dismiss();
                            break;

                        case DialogInterface.BUTTON_NEGATIVE:
                            new GetListeColisAsyncTask().execute();
                            dialog.dismiss();
                            break;
                    }
                }
            };
            AlertDialog.Builder builder = new AlertDialog.Builder(this);
            builder.setMessage("Tous les colis n'ont pas été scannés, voulez-vous vraiment rafraîchir la liste ?");
            builder.setNegativeButton("Oui", dialogClickListener);
            builder.setPositiveButton("Non", dialogClickListener);
            builder.show();
        } else {
            new GetListeColisAsyncTask().execute();
        }
    }


    public void produitScanner(String code128) {
        int i = getColisPos(code128);
        int max = currentListeAScanner.size();
        if (i < max) {
            Colis c = currentListeAScanner.get(i);
            if (c.getPret() == 1) {
                Toast.makeText(ColisActivity.this, "Colis déjà scanné!", Toast.LENGTH_LONG);
            } else {
                c.setPret(1);
                dernierCodeColis = c.getCodeColis();
                c.setEnvoye(0);
                dernierColisEnvoye = c.getEnvoye();
                new UpdateColisAsyncTask().execute();
                if (isAllScanned() && currentListeAScanner.size() != 0) {
                    final Dialog myDialog = new Dialog(this);
                    myDialog.setContentView(R.layout.popup_ok);

                    Button b = myDialog.findViewById(R.id.txt);
                    b.setText("OK");
                    b.setBackground(getDrawable(R.drawable.rounded_corner));
                    b.setOnClickListener(new View.OnClickListener() {
                        @Override
                        public void onClick(View view) {
                            myDialog.dismiss();

                        }
                    });
                    myDialog.getWindow().setBackgroundDrawable(new ColorDrawable(Color.TRANSPARENT));
                    myDialog.show();

                    //afficheVide();

                }
                afficheColis();
            }
        } else {
            afficheCroixRouge();
        }
    }

    public void delColis(Colis c){
        currentListeAScanner.remove(c);
        mAdapter.setListeColis(currentListeAScanner);
        mAdapter.notifyDataSetChanged();
        afficheColis();
    }

    public void afficheCroixRouge(){
        final Dialog myDialog = new Dialog(this);
        myDialog.setContentView(R.layout.popup_ok);
        Button b = myDialog.findViewById(R.id.txt);
        b.setText("X");
        b.setBackground(getDrawable(R.drawable.rounded_corner_x));
        myDialog.getWindow().setBackgroundDrawable(new ColorDrawable(Color.TRANSPARENT));
        // Hide after some seconds
        final Handler handler  = new Handler();
        final Runnable runnable = new Runnable() {
            @Override
            public void run() {
                if (myDialog.isShowing()) {
                    myDialog.dismiss();
                }
            }
        };

        myDialog.setOnDismissListener(new DialogInterface.OnDismissListener() {
            @Override
            public void onDismiss(DialogInterface dialog) {
                handler.removeCallbacks(runnable);
            }
        });
        handler.postDelayed(runnable, 1000);
        jouerSon();
        myDialog.show();
    }


    public boolean isAllScanned(){
        if (currentListeAScanner != null) {
            int cptScanner = 0;
            int cptTot = currentListeAScanner.size();
            for (Colis c : currentListeAScanner) {
                cptScanner += c.getPret();
            }
            return cptTot == cptScanner;
        } else {
            return true;
        }
    }


    @Override
    public void onCheckedChanged(CompoundButton arg0, boolean arg1) {
        bDecoderSettingsChanged = true;
        cancelRead();
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        int id = item.getItemId();
        if (id == R.id.action_settings) {
            return true;
        }
        return super.onOptionsItemSelected(item);
    }

    //BASE DE DONNES
    private class GetListeColisAsyncTask extends AsyncTask<String, String, String> {

        //BASE DE DONNES
        private final String BASE_URL = MainActivity.backOfficeURL;

        private int success;

        @Override
        protected void onPreExecute() {
            super.onPreExecute();
        }

        @Override
        protected String doInBackground(String... params) {

                        //recuperation des produits de la commande
                        HttpJsonParser httpJsonParser = new HttpJsonParser();
                        JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                                BASE_URL + "getListeColis.php", "GET", null);

                        List<Colis> colisList = new ArrayList<>();

                        try {
                            int success = jsonObject.getInt("success");
                            JSONArray colisArray;
                            if (success == 1) {
                                colisArray = jsonObject.getJSONArray("data");
                                for (int i = 0; i < colisArray.length(); i++) {
                                    Colis c = new Colis();
                                    JSONObject colis = colisArray.getJSONObject(i);

                                    try {
                                        c.setNumeroCommande(colis.getString("numero_commande"));
                                        c.setCodeColis(colis.getString("code_colis"));
                                        c.setNumeroColis(colis.getInt("numero_colis"));
                                        c.setNomClient(colis.getString("nom_client"));
                                        c.setPret(colis.getInt("pret"));
                                        c.setQuantite_colis(colis.getInt("quantite_colis"));
                                        c.setEnvoye(colis.getInt("envoye"));
                                        colisList.add(c);
                                    }catch (Exception e){
                                        e.printStackTrace();
                                    }
                                }
                                try {
                                    currentListeAScanner = colisList;
                                }catch (Exception e){
                                    e.printStackTrace();
                                }
                            }
                        } catch (JSONException e) {
                            e.printStackTrace();
                        }

            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            if (currentListeAScanner == null || currentListeAScanner.size() == 0){
                AlertDialog.Builder alertDialog = new AlertDialog.Builder(ColisActivity.this);
                alertDialog.setTitle("Colis");
                alertDialog.setMessage("Aucun colis à expédier!");

                alertDialog.setPositiveButton("OK", new DialogInterface.OnClickListener() {
                    public void onClick(DialogInterface dialog, int whichButton) {
                        dialog.dismiss();
                        finish();
                    }
                });
                alertDialog.show();
                //afficheVide();
            }else{
                afficheColis();
            }
        }
    }

    private class UpdateColisAsyncTask extends AsyncTask<String, String, String> {

        private final String BASE_URL = MainActivity.backOfficeURL;

        private int success;

        @Override
        protected void onPreExecute() {
            super.onPreExecute();

        }

        @Override
        protected String doInBackground(String... params) {
            HttpJsonParser httpJsonParser1 = new HttpJsonParser();
            Map<String, String> httpParams1 = new HashMap<>();
            httpParams1.put("code_colis", dernierCodeColis);
            httpParams1.put("envoye", ""+dernierColisEnvoye);

            JSONObject jsonObject1 = httpJsonParser1.makeHttpRequest(
                    BASE_URL + "updateColis.php", "POST", httpParams1);
            try {
                success = jsonObject1.getInt("success");
            } catch (JSONException e) {
                e.printStackTrace();
            }

            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            if (success == 1) {
                Toast.makeText(ColisActivity.this, "Colis "+dernierCodeColis+ " prêt!", Toast.LENGTH_SHORT);
            }
        }

    }

    void jouerSon() {
        mediaPlayer = new MediaPlayer();
        try {
            AssetFileDescriptor afd = null;
            afd = getResources().getAssets().openFd("notification.mp3");
            /*if (filename != "erreurProduit_v2.mp3") {
                mediaPlayer.setVolume(0.2f,0.2f);
            } else {*/
            mediaPlayer.setVolume(1.0f,1.0f);
            //}
            mediaPlayer.setDataSource(afd.getFileDescriptor(), afd.getStartOffset(), afd.getLength());
            mediaPlayer.prepareAsync();
        } catch (IllegalArgumentException e) {
            e.printStackTrace();
        } catch (IllegalStateException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
        //Lancer en mode asynchrone pour continuer en permanence
        mediaPlayer.setOnPreparedListener(mp -> mp.start());
        //Release après lecture
        mediaPlayer.setOnCompletionListener(mp -> {
            if (mp != null) {
                mp.release();
            }
        });
    }

}
