package fr.itsee.season;

import android.os.Parcel;
import android.os.Parcelable;
import android.widget.Toast;

import java.util.ArrayList;
import java.util.List;

public class Commande implements Parcelable {

    private String num, nomClient = "", prenomClient = "", adresseClient = "", codePostalClient = "", villeClient = "", paysClient = "", date, webNomClient = "", webPrenomClient = "", webAdresseClient = "", webCodePostalClient = "", webVilleClient = "", webPaysClient = "", webTel1Client = "", webTel2Client = "", webMailClient = "", webStatutClient = "", raisonsocialeClient = "", lRaisonsocialeClient = "", commentaireClient = "", webCommentaireClient = "", telephoneClient = "", MCModePaiement = "", numFacture = "", emailClient = "";
    private int qtetotal, nbrColis = 0, poids = 0, lien_paiement_envoye;
    private double prixTotal, fraisDePortClient, montantTotalHTPaye, prixLivraisonMax4, prixLivraisonMax8, prixLivraisonMax15, prixLivraisonMax30, prixLivraison;
    private String modeLivraison = "aucun";
    private List<Produit> listeProduit;
    private List<Colis> listeColis;


    public Commande(){
        this.listeProduit = new ArrayList<>();
        this.listeColis = new ArrayList<>();
    }

    protected Commande(Parcel in) {
        num = in.readString();
        nomClient = in.readString();
        date = in.readString();
        qtetotal = in.readInt();
        prixTotal = in.readDouble();
        modeLivraison = in.readString();
        listeProduit = in.readArrayList(Produit.class.getClassLoader());
        webPrenomClient = in.readString();
        webAdresseClient = in.readString();
        webCodePostalClient = in.readString();
        webVilleClient = in.readString();
        webTel1Client = in.readString();
        webTel2Client = in.readString();
        webMailClient = in.readString();
        webStatutClient = in.readString();
        prenomClient = in.readString();
        adresseClient = in.readString();
        codePostalClient = in.readString();
        villeClient = in.readString();
        webNomClient = in.readString();
        raisonsocialeClient = in.readString();
        lRaisonsocialeClient = in.readString();
        montantTotalHTPaye = in.readDouble();
        paysClient = in.readString();
        webPaysClient = in.readString();
        commentaireClient = in.readString();
        webCommentaireClient = in.readString();
        telephoneClient = in.readString();
        fraisDePortClient = in.readDouble();
        MCModePaiement = in.readString();
        numFacture = in.readString();
        prixLivraisonMax4 = in.readDouble();
        prixLivraisonMax8 = in.readDouble();
        prixLivraisonMax15 = in.readDouble();
        prixLivraisonMax30 = in.readDouble();
        prixLivraison = in.readDouble();
        nbrColis = in.readInt();
        listeColis = in.readArrayList(Colis.class.getClassLoader());
        poids = in.readInt();
        emailClient = in.readString();
        lien_paiement_envoye = in.readInt();
    }

    public static final Creator<Commande> CREATOR = new Creator<Commande>() {
        @Override
        public Commande createFromParcel(Parcel in) {
            return new Commande(in);
        }

        @Override
        public Commande[] newArray(int size) {
            return new Commande[size];
        }
    };

    public void addProduit(Produit p){
        listeProduit.add(0, p);
        incPrixTotal(p.getPrixTotale());
        qtetotal = listeProduit.size();
    }

    public void delProduit(Produit p){
        listeProduit.remove(p);
        decPrixTotal(p.getPrixTotale());
        qtetotal = listeProduit.size();
    }

    public void addColis(Colis c){
        listeColis.add(0, c);
        nbrColis = listeColis.size();
    }

    public void delColis(Colis c){
        listeColis.remove(c);
        nbrColis = listeColis.size();
    }


    public void incPrixTotal(double n){
        this.prixTotal += n;
    }

    public void decPrixTotal(double n){
        this.prixTotal -= n;
    }

    public void setPoids(int poids){
        this.poids = poids;
    }

    public int getPoids() { return this.poids; }

    public List<Produit> getListeProduit() {
        return listeProduit;
    }

    public List<Colis> getListeColis() {
        return listeColis;
    }

    public String getModeLivraison() {
        return modeLivraison;
    }

    public String getDate() {
        return date;
    }

    public String getNum() {
        return num;
    }

    public int getQtetotal() {
        int cpt = 0;
        for (Produit p : listeProduit){
            cpt += p.getQte();
        }
        qtetotal = cpt;
        return qtetotal;
    }

    public String getNomClient() {
        return nomClient;
    }

    public String getPrenomClient() {
        return prenomClient;
    }

    public String getAdresseClient() {
        return adresseClient;
    }

    public String getCodePostalClient() {
        return codePostalClient;
    }

    public String getVilleClient() {
        return villeClient;
    }

    public String getPaysClient() { return paysClient; }

    public String getCommentaireClient() { return commentaireClient; }


    public double getPrixTotal() {
        double cpt = 0;
        for (Produit p : listeProduit){
            cpt += p.getPrixTotale();
        }
        prixTotal = cpt;
        return prixTotal;
    }

    public String getEmailClient() {
        return emailClient;
    }

    public void setPrixLivraisonMax4(Double prixLivraisonMax4) { this.prixLivraisonMax4 = prixLivraisonMax4; }
    public void setPrixLivraisonMax8(Double prixLivraisonMax8) { this.prixLivraisonMax8 = prixLivraisonMax8; }
    public void setPrixLivraisonMax15(Double prixLivraisonMax15) { this.prixLivraisonMax15 = prixLivraisonMax15; }
    public void setPrixLivraisonMax30(Double prixLivraisonMax30) { this.prixLivraisonMax30 = prixLivraisonMax30; }
    public void setPrixLivraison(Double prixLivraisonMax4) { this.prixLivraison = prixLivraison; }

    public Double getPrixLivraisonMax4() { return this.prixLivraisonMax4; }
    public Double getPrixLivraisonMax8() { return this.prixLivraisonMax8; }
    public Double getPrixLivraisonMax15() { return this.prixLivraisonMax15; }
    public Double getPrixLivraisonMax30() { return this.prixLivraisonMax30; }
    public Double getPrixLivraison() { return this.prixLivraison; }

    public void setWebNomClient(String webNomClient) {
        this.webNomClient = webNomClient;
    }

    public String getWebNomClient() { return webNomClient; }

    public void setWebPrenomClient(String webPrenomClient) {
        this.webPrenomClient = webPrenomClient;
    }

    public String getWebPrenomClient() {
        return webPrenomClient;
    }

    public void setWebAdresseClient(String webAdresseClient) {
        this.webAdresseClient = webAdresseClient;
    }

    public String getWebAdresseClient() {
        return webAdresseClient;
    }

    public String getWebCodePostalClient() {
        return webCodePostalClient;
    }

    public void setWebCodePostalClient(String webCodePostalClient) {
        this.webCodePostalClient = webCodePostalClient;
    }

    public String getWebVilleClient() {
        return webVilleClient;
    }

    public void setWebVilleClient(String webVilleClient) {
        this.webVilleClient = webVilleClient;
    }

    public String getWebPaysClient() {
        return webPaysClient;
    }

    public void setWebPaysClient(String webPaysClient) {
        this.webPaysClient = webPaysClient;
    }

    public void setWebCommentaireClient(String webCommentaireClient) {
        this.webCommentaireClient = webCommentaireClient;
    }
    public String getWebCommentaireClient() { return webCommentaireClient; }

    public String getWebTel1Client() {
        return webTel1Client;
    }

    public void setWebTel1Client(String webTel1Client) {
        this.webTel1Client = webTel1Client;
    }

    public String getWebTel2Client() {
        return webTel2Client;
    }

    public void setWebTel2Client(String webTel2Client) {
        this.webTel2Client = webTel2Client;
    }

    public String getWebMailClient() {
        return webMailClient;
    }

    public void setWebMailClient(String webMailClient) {
        this.webMailClient = webMailClient;
    }

    public String getWebStatutClient() {
        return webStatutClient;
    }

    public String getRaisonsocialeClient() { return raisonsocialeClient; }

    public double getFraisDePortClient() { return fraisDePortClient; }

    public double getMontantTotalHTPaye() { return montantTotalHTPaye; }

    public String getTelephoneClient() { return telephoneClient; }

    public int getLien_paiement_envoye() { return lien_paiement_envoye; }

    public void setWebStatutClient(String webStatutClient) {
        this.webStatutClient = webStatutClient;
    }

    public void setDate(String date) {
        this.date = date;
    }

    public void setNomClient(String nomClient) {
        this.nomClient = nomClient;
    }

    public void setPrenomClient(String prenomClient) {
        this.prenomClient = prenomClient;
    }

    public void setAdresseClient(String adresseClient) {
        this.adresseClient = adresseClient;
    }

    public void setCodePostalClient(String codePostalClient) { this.codePostalClient = codePostalClient; }

    public void setVilleClient(String villeClient) {
        this.villeClient = villeClient;
    }

    public void setPaysClient(String paysClient) {
        this.paysClient = paysClient;
    }

    public void setCommentaireClient(String commentaireClient) {
        this.commentaireClient = commentaireClient;
    }

    public void setNum(String num) {
        this.num = num;
    }

    public void setQtetotal(int qtetotal) {
        this.qtetotal = qtetotal;
    }

    public void setListeProduit(List<Produit> listeProduit) {
        this.listeProduit = listeProduit;
    }

    public void setListeColis(List<Colis> listeColis) {
        this.listeColis = listeColis;
    }

    public void setModeLivraison(String modeLivraison) {
        this.modeLivraison = modeLivraison;
    }

    public void setPrixTotal(double prixTotal) {
        this.prixTotal = prixTotal;
    }

    public void setRaisonSocialeClient(String raisonsocialeClient) {this.raisonsocialeClient = raisonsocialeClient; }

    public void setlRaisonsocialeClient(String lRaisonsocialeClient) {this.lRaisonsocialeClient = lRaisonsocialeClient; }

    public void setFraisDePortClient(Double fraisDePortClient) {this.fraisDePortClient = fraisDePortClient; }

    public void setMontantTotalHTPaye(Double montantTotalHTPaye) { this.montantTotalHTPaye = montantTotalHTPaye; }

    public void setTelephoneClient(String telephoneClient) { this.telephoneClient = telephoneClient; }

    public String getLRaisonsocialeClient() { return lRaisonsocialeClient; }

    public void setMCModePaiement(String mcModePaiement) { this.MCModePaiement = mcModePaiement; }

    public String getMCModePaiement() { return MCModePaiement; }

    public void setNumFacture(String numFacture) { this.numFacture = numFacture;}

    public String getNumFacture() { return numFacture; }

    public void setNbrColis(Integer nbrColis) { this.nbrColis = nbrColis; }
    public Integer getNbrColis() { return this.nbrColis; }

    public void setEmailClient(String emailClient) { this.emailClient = emailClient; }

    public void setLien_paiement_envoye(int lien_paiement_envoye) { this.lien_paiement_envoye = lien_paiement_envoye; }

    @Override
    public String toString() {
        return "" + num + ": " + listeProduit + ":"+ listeColis;
    }

    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel parcel, int i) {
        parcel.writeString(num);
        parcel.writeString(nomClient);
        parcel.writeString(date);
        parcel.writeInt(qtetotal);
        parcel.writeDouble(prixTotal);
        parcel.writeString(modeLivraison);
        parcel.writeList(listeProduit);
        parcel.writeString(webPrenomClient);
        parcel.writeString(webAdresseClient);
        parcel.writeString(webCodePostalClient);
        parcel.writeString(webVilleClient);
        parcel.writeString(webTel1Client);
        parcel.writeString(webTel2Client);
        parcel.writeString(webMailClient);
        parcel.writeString(webStatutClient);
        parcel.writeString(prenomClient);
        parcel.writeString(adresseClient);
        parcel.writeString(codePostalClient);
        parcel.writeString(villeClient);
        parcel.writeString(webNomClient);
        parcel.writeString(raisonsocialeClient);
        parcel.writeString(lRaisonsocialeClient);
        parcel.writeDouble(montantTotalHTPaye);
        parcel.writeString(paysClient);
        parcel.writeString(webPaysClient);
        parcel.writeString(commentaireClient);
        parcel.writeString(webCommentaireClient);
        parcel.writeString(telephoneClient);
        parcel.writeDouble(fraisDePortClient);
        parcel.writeString(MCModePaiement);
        parcel.writeString(numFacture);
        parcel.writeList(listeColis);
        parcel.writeString(emailClient);
        parcel.writeInt(lien_paiement_envoye);
    }

}
