package fr.itsee.season;

import android.os.Parcel;
import android.os.Parcelable;

public class Produit implements Parcelable, Comparable<Produit> {

    private String ref;
    private String coloris;
    private String commandable;
    private String code_128;
    private int quantite_packs;
    private double prix;
    private int stock;
    private String numero_de_rayon;
    private String informations;
    private String lien_image;
    private int actif;
    private int qte;
    private int nbrScanner;
    private double poids;

    public Produit(){

    }

    public Produit(Produit p){
        this.ref = p.getRef();
        this.coloris = p.getColoris();
        this.commandable = p.getCommandable();
        this.code_128 = p.getCode128();
        this.quantite_packs = p.getQuantite_pack();
        this.prix = p.getPrix();
        this.stock = p.getStock();
        this.numero_de_rayon = p.getNumero_de_rayon();
        this.informations = p.getInformations();
        this.lien_image = p.getLien_image();
        this.actif = p.getActif();
        this.qte = p.getQte();
        this.nbrScanner = p.getNbrScanner();
        this.poids = p.getPoids();
    }


    protected Produit(Parcel in) {
        ref = in.readString();
        coloris = in.readString();
        commandable = in.readString();
        code_128 = in.readString();
        quantite_packs = in.readInt();
        prix = in.readDouble();
        stock = in.readInt();
        numero_de_rayon = in.readString();
        informations = in.readString();
        lien_image = in.readString();
        actif = in.readInt();
        qte = in.readInt();
        nbrScanner = in.readInt();
        poids = in.readDouble();
    }

    public static final Creator<Produit> CREATOR = new Creator<Produit>() {
        @Override
        public Produit createFromParcel(Parcel in) {
            return new Produit(in);
        }

        @Override
        public Produit[] newArray(int size) {
            return new Produit[size];
        }
    };

    @Override
    public int compareTo(Produit produit) {
        return this.getCode128().compareTo(produit.getCode128());
    }


    public int getNbrScanner() {
        return nbrScanner;
    }

    public void setNbrScanner(int nbrScanner) {
        this.nbrScanner = nbrScanner;
    }

    public String getColoris() {
        return coloris;
    }

    public String getRef() {
        return ref;
    }

    public double getPrix() {
        return prix;
    }

    public double getPoids() {
        return poids;
    }

    public double getPrixTotale() {
        return (double)Math.round((prix * quantite_packs * qte) * 100d) / 100d;
    }

    public int getQte() {
        return qte;
    }

    public void setColoris(String coloris) {
        this.coloris = coloris;
    }

    public void setRef(String ref) {
        this.ref = ref;
    }

    public void setPrix(double prix) {
        this.prix = prix;
    }

    public void setPoids(double poids) {
        this.poids = poids;
    }

    public void setQte(int qte) {
        this.qte = qte;
    }

    public int getActif() {
        return actif;
    }

    public String getCommandable() {
        return commandable;
    }

    public String getNumero_de_rayon() {
        return numero_de_rayon;
    }

    public int getStock() {
        return stock;
    }

    public int getQuantite_pack() {
        return quantite_packs;
    }

    public String getCode128() {
        return code_128;
    }

    public String getInformations() {
        return informations;
    }

    public String getLien_image() {
        return lien_image;
    }

    public void setActif(int actif) {
        this.actif = actif;
    }

    public void setCode128(String code_128) {
        this.code_128 = code_128;
    }

    public void setCommandable(String commandable) {
        this.commandable = commandable;
    }

    public void setInformations(String informations) {
        this.informations = informations;
    }

    public void setLien_image(String lien_image) {
        this.lien_image = lien_image;
    }

    public void setNumero_de_rayon(String numero_de_rayon) {
        this.numero_de_rayon = numero_de_rayon;
    }

    public void setQuantite_pack(int quantite_packs) {
        this.quantite_packs = quantite_packs;
    }

    public void setStock(int stock) {
        this.stock = stock;
    }

    public void incQte(){
        this.qte += 1;
    }

    public void decQte(){
        this.qte -= 1;
    }

    @Override
    public String toString() {
        return "" + code_128 + ": Qté:" + qte + "Stock: " + stock;
    }

    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel parcel, int i) {
        parcel.writeString(ref);
        parcel.writeString(coloris);
        parcel.writeString(commandable);
        parcel.writeString(code_128);
        parcel.writeInt(quantite_packs);
        parcel.writeDouble(prix);
        parcel.writeInt(stock);
        parcel.writeString(numero_de_rayon);
        parcel.writeString(informations);
        parcel.writeString(lien_image);
        parcel.writeInt(actif);
        parcel.writeInt(qte);
        parcel.writeInt(nbrScanner);
        parcel.writeDouble(poids);
    }
}
