package fr.itsee.season;

import android.app.Activity;
import android.app.AlertDialog;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.pm.ActivityInfo;
import android.content.res.AssetFileDescriptor;
import android.graphics.Bitmap;
import android.icu.text.DecimalFormat;
import android.media.MediaPlayer;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.AsyncTask;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.DefaultItemAnimator;
import android.support.v7.widget.DividerItemDecoration;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.text.Html;
import android.text.method.ScrollingMovementMethod;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.EditText;
import android.widget.RelativeLayout;
import android.widget.ScrollView;
import android.widget.SearchView;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import com.google.gson.Gson;
import com.google.gson.reflect.TypeToken;
import com.symbol.emdk.EMDKManager;
import com.symbol.emdk.EMDKManager.EMDKListener;
import com.symbol.emdk.EMDKManager.FEATURE_TYPE;
import com.symbol.emdk.EMDKResults;
import com.symbol.emdk.barcode.BarcodeManager;
import com.symbol.emdk.barcode.BarcodeManager.ConnectionState;
import com.symbol.emdk.barcode.BarcodeManager.ScannerConnectionListener;
import com.symbol.emdk.barcode.ScanDataCollection;
import com.symbol.emdk.barcode.ScanDataCollection.ScanData;
import com.symbol.emdk.barcode.Scanner;
import com.symbol.emdk.barcode.Scanner.DataListener;
import com.symbol.emdk.barcode.Scanner.StatusListener;
import com.symbol.emdk.barcode.Scanner.TriggerType;
import com.symbol.emdk.barcode.ScannerConfig;
import com.symbol.emdk.barcode.ScannerException;
import com.symbol.emdk.barcode.ScannerInfo;
import com.symbol.emdk.barcode.ScannerResults;
import com.symbol.emdk.barcode.StatusData;
import com.symbol.emdk.barcode.StatusData.ScannerStates;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.IOException;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

public class ReglementActivity extends AppCompatActivity implements EMDKListener, DataListener, StatusListener, ScannerConnectionListener, CompoundButton.OnCheckedChangeListener {
    /*public class ReglementActivity extends AppCompatActivity {*/

    private RecyclerView recyclerView;
    public static ProduitAdapterReglement mAdapter;

    public static int dernierePosition = -1;

    private TextView date, num, mode, txtChargement, txtNumeroCommande;
    public static TextView prixTotal, qteTotal, livraisonTotalHt, prixTotalTtc;
    private SearchView searchBar;
    private TextView nom;
    private Button newC, valider, livraison;

    private int selectedTab = 1;

    private int ancienNbrColis = 0;

    public static Map<String, Bitmap> dicImages;
    public static List<Produit> listeAllProduits;
    public static List<Transporteur> listeAllTransporteurs;
    List<Commande> listeCommande = new ArrayList<>(1);
    public static Commande currentCommande;

    private Commande newCommande,newCommandeTab2,newCommandeTab3;
    private final Commande commandeVide = new Commande();
    public static Commande commandeAImprimer = new Commande();

    public List<Produit> listeRupture;

    private RelativeLayout reprendreCommande;
    private Button reprendreCommandeButton;

    //Partie Scanner
    private EMDKManager emdkManager = null;
    private BarcodeManager barcodeManager = null;
    private Scanner scanner = null;

    private TextView textViewData = null;
    private TextView textViewStatus = null;

    private CheckBox checkBoxEAN8 = null;
    private CheckBox checkBoxEAN13= null;
    private CheckBox checkBoxCode39= null;
    private CheckBox checkBoxCode128= null;

    private Spinner spinnerScannerDevices= null;

    private List<ScannerInfo> deviceList = null;

    private final RecyclerView listeCommandes = null;

    private int scannerIndex = 0; // Keep the selected scanner
    private int defaultIndex = 0; // Keep the default scanner
    private int dataLength = 0;
    private String statusString = "";

    private boolean bSoftTriggerSelected = false;
    private boolean bDecoderSettingsChanged = false;
    private boolean bExtScannerDisconnected = false;
    private final Object lock = new Object();

    //Son
    private MediaPlayer mediaPlayer;

    private String numeroCommande;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_reglement);

        reprendreCommande = findViewById(R.id.reprendreCommande);
        txtChargement = findViewById(R.id.txtChargement);
        txtNumeroCommande = findViewById(R.id.editTxtNumeroCommande);

        //Permet de créer de nouvelles commandes automatiquement à minuit sauf le dimanche
        //Calcul de la prochaine exécution à minuit
        /*long actualTimeStamp = System.currentTimeMillis();
        Calendar c = new GregorianCalendar();
        c.add(Calendar.DATE, 1);
        c.set(Calendar.HOUR_OF_DAY, 0);
        c.set(Calendar.MINUTE, 0);
        c.set(Calendar.SECOND, 0);
        long tomorrowTimeStamp = c.getTimeInMillis();*/

        try {
            new GetAllTransporteursAsyncTask().execute();
            new GetAllProduitsAsyncTask().execute();
        }catch (Exception e){
            e.printStackTrace();
        }

        date = findViewById(R.id.date);
        num = findViewById(R.id.num);
        nom = findViewById(R.id.nom);
        prixTotal = findViewById(R.id.prixTotalHt);
        prixTotalTtc = findViewById(R.id.prixTotalTtc);
        searchBar = findViewById(R.id.bar_de_recherche);
        newC = findViewById(R.id.newC);
        valider = findViewById(R.id.valider);
        livraison = findViewById(R.id.livraison);
        qteTotal = findViewById(R.id.qteTotal);

        mode = findViewById(R.id.mode);

        livraisonTotalHt = findViewById(R.id.livraisonTotalHt);
        reprendreCommandeButton = findViewById(R.id.reprendreCommandeButton);

        dicImages = new HashMap<>();
        mAdapter = new ProduitAdapterReglement( new Commande(), getApplicationContext());

        listeCommande.add(null);

        getListeCommandes();

        recyclerView = findViewById(R.id.recycler_view);
        textViewData = findViewById(R.id.textViewData);
        textViewStatus = findViewById(R.id.textViewStatus);
        checkBoxEAN8 = findViewById(R.id.checkBoxEAN8);
        checkBoxEAN13 = findViewById(R.id.checkBoxEAN13);
        checkBoxCode39 = findViewById(R.id.checkBoxCode39);
        checkBoxCode128 = findViewById(R.id.checkBoxCode128);
        spinnerScannerDevices = findViewById(R.id.spinnerScannerDevices);

        currentCommande = listeCommande.get(selectedTab - 1);

        //2023070702 - Afficher la fenêtre charger commande
        if (currentCommande == null || currentCommande.getNum() == null) {
            reprendreCommande.setVisibility(View.VISIBLE);
            txtNumeroCommande.setVisibility(View.VISIBLE);
            txtNumeroCommande.hasFocus();
        }

        RecyclerView.LayoutManager mLayoutManager = new LinearLayoutManager(getApplicationContext());
        recyclerView.setLayoutManager(mLayoutManager);
        recyclerView.setItemAnimator(new DefaultItemAnimator());
        recyclerView.addItemDecoration(new DividerItemDecoration(this, LinearLayoutManager.VERTICAL));
        recyclerView.setAdapter(mAdapter);
        mAdapter.setOnItemClickListener(new ProduitAdapterReglement.OnItemClickListener() {

            @Override
            public void onPhotoClik(int position) {
                dernierePosition = position;
                Intent intent = new Intent(ReglementActivity.this, FicheProduitReglementActivity.class);
                intent.putExtra("produit", getProduit(position));
                startActivityForResult(intent, 3);
            }

            @Override
            public void onSupprClick(int position) {
                currentCommande.delProduit(getProduit(position));
                dernierePosition = -1;
                mAdapter.notifyDataSetChanged();
                afficheCommande();
            }

            @Override
            public void onPlusClick(int position) {
                Produit p = getProduit(position);
                dernierePosition = position;
                Toast.makeText(ReglementActivity.this,"position:"+position,Toast.LENGTH_SHORT);
                //actualisation du stock de ce produit direct en BDD
                HttpJsonParser httpJsonParser2 = new HttpJsonParser();
                Map<String, String> httpParams2 = new HashMap<>();
                httpParams2.put("code_128", currentCommande.getListeProduit().get(position).getCode128());
                JSONObject jsonObject2 = httpJsonParser2.makeHttpRequest(
                        MainActivity.backOfficeURL + "getStockProduit.php", "GET", httpParams2);

                try {
                    int success = jsonObject2.getInt("success");
                    if (success == 1){
                        JSONObject produit = jsonObject2.getJSONArray("data").getJSONObject(0);
                        if (produit.getString("stock") == "null" || produit.getString("stock") == null) {
                            p.setStock(0);
                            currentCommande.getListeProduit().get(position).setStock(0);
                        } else {
                            p.setStock(Integer.parseInt(produit.getString("stock")));
                            currentCommande.getListeProduit().get(position).setStock(Integer.parseInt(produit.getString("stock")));
                        }
                    }

                } catch (JSONException e) {
                    e.printStackTrace();
                }

                int reste = p.getStock() - p.getQte() - 1;

                //Si le stock épuisé, alors alerte sonore
                if(p.getStock() - p.getQte() == 0){
                    jouerSon();
                }

                if (reste <= 1 && reste > 0){
                    //20230620, on laisse quand même on ne sait jamais
                    p.incQte();
                    Toast.makeText(getApplicationContext(), "Stock inférieur à 2!", Toast.LENGTH_SHORT).show();
                }else if(reste == 0){
                    Toast.makeText(getApplicationContext(), "Stock épuisé!", Toast.LENGTH_SHORT).show();
                    p.incQte();
                }else if (reste < -2){ // MODIF ITSEE 20190701 16:16 transforme == -2 vers < -2
                    Toast.makeText(getApplicationContext(), "Stock négatif!", Toast.LENGTH_SHORT).show();
                    p.incQte();
                }
                else{
                    p.incQte();
                }
                afficheCommande();
            }

            @Override
            public void onMoinsClick(int position) {
                Produit p = getProduit(position);
                dernierePosition = position;
                //actualisation du stock de ce produit direct en BDD
                HttpJsonParser httpJsonParser2 = new HttpJsonParser();
                Map<String, String> httpParams2 = new HashMap<>();
                httpParams2.put("code_128", currentCommande.getListeProduit().get(position).getCode128());
                JSONObject jsonObject2 = httpJsonParser2.makeHttpRequest(
                        MainActivity.backOfficeURL + "getStockProduit.php", "GET", httpParams2);

                try {
                    int success = jsonObject2.getInt("success");
                    if (success == 1){
                        JSONObject produit = jsonObject2.getJSONArray("data").getJSONObject(0);
                        if (produit.getString("stock") == "null" || produit.getString("stock") == null) {
                            p.setStock(0);
                            currentCommande.getListeProduit().get(position).setStock(0);
                        } else {
                            p.setStock(Integer.parseInt(produit.getString("stock")));
                            currentCommande.getListeProduit().get(position).setStock(Integer.parseInt(produit.getString("stock")));
                        }
                    }

                } catch (JSONException e) {
                    e.printStackTrace();
                }

                if (p.getQte() == 1){
                    currentCommande.delProduit(getProduit(position));
                    dernierePosition = -1;
                }else{
                    currentCommande.getListeProduit().get(position).decQte();
                }
                afficheCommande();
            }

            @Override
            public void onQuantiteClick(int position) {
                DialogReglementActivityEditQte.show(ReglementActivity.this, position);
            }
        });


        searchBar.setOnQueryTextListener(new SearchView.OnQueryTextListener() {
            @Override
            public boolean onQueryTextSubmit(String s) {
                searchBar.clearFocus();
                if (ReglementActivity.listeAllProduits != null) {
                    Intent intent = new Intent(ReglementActivity.this, RechercheReglementActivity.class);
                    intent.putExtra("recherche", s);
                    startActivityForResult(intent, 4);
                }
                return false;
            }

            @Override
            public boolean onQueryTextChange(String s) {
                return false;
            }
        });

        currentCommande = listeCommande.get(selectedTab - 1);

        if (currentCommande != null){
            mAdapter.setCmd(currentCommande);
            recyclerView.setAdapter(mAdapter);
            afficheCommande();
        } else {
            reprendreCommande.setVisibility(View.VISIBLE);
            txtNumeroCommande.setVisibility(View.VISIBLE);
            txtNumeroCommande.hasFocus();
        }

        //Permet de saisir manuellement les informations
        txtNumeroCommande.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                reprendreCommandeButton.setVisibility(View.VISIBLE);
            }
        });


        deviceList = new ArrayList<ScannerInfo>();

        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_NOSENSOR);

        EMDKResults results = EMDKManager.getEMDKManager(getApplicationContext(), this);
        if (results.statusCode != EMDKResults.STATUS_CODE.SUCCESS) {
            updateStatus("EMDKManager object request failed!");
            return;
        }

        checkBoxEAN8.setOnCheckedChangeListener(this);
        checkBoxEAN13.setOnCheckedChangeListener(this);
        checkBoxCode39.setOnCheckedChangeListener(this);
        checkBoxCode128.setOnCheckedChangeListener(this);

        addSpinnerScannerDevicesListener();
        textViewData.setSelected(true);
        textViewData.setMovementMethod(new ScrollingMovementMethod());


        nom.setOnEditorActionListener(new TextView.OnEditorActionListener() {
            @Override
            public boolean onEditorAction(TextView textView, int i, KeyEvent keyEvent) {
                currentCommande.setNomClient(String.valueOf(textView.getText()));
                return false;
            }
        });

        nom.setOnFocusChangeListener(new View.OnFocusChangeListener() {
            @Override
            public void onFocusChange(View view, boolean b) {
                currentCommande.setNomClient(String.valueOf(((EditText)view).getText()));
            }
        });

    }

    public Produit getProduit(int position){
        return currentCommande.getListeProduit().get(position);
    }

    @Override
    protected void onStop() {
        super.onStop();
        saveListeCommandes();
    }

    //20230702 - Attention, il faut bien mettre un nom différent ici car sinon on écrase les commandes de la partie commandes
    public void saveListeCommandes(){
        SharedPreferences sharedPreferences = this.getSharedPreferences("PREFS", Context.MODE_PRIVATE);
        Gson gson = new Gson();
        sharedPreferences.edit().putString("listeCommandeReglement",gson.toJson(listeCommande)).apply();
    }

    public void getListeCommandes(){
        SharedPreferences sharedPreferences = this.getSharedPreferences("PREFS", Context.MODE_PRIVATE);
        Gson gson = new Gson();

        String json = sharedPreferences.getString("listeCommandeReglement",null);

        if(json != null){
            listeCommande = gson.fromJson(json,new TypeToken<List<Commande>>() {}.getType());
        }
    }

    public void afficheCommande(){
        currentCommande = listeCommande.get(selectedTab - 1);

        if (currentCommande != null){
            //20230701 - Au chargemnent si une commande est déjà active, on affiche pas la demande de saisir un numéro de commande
            reprendreCommande.setVisibility(View.GONE);
            reprendreCommandeButton.setVisibility(View.INVISIBLE);

            date.setText("Date: " + currentCommande.getDate());
            num.setText("N°: " + currentCommande.getNum());
            mode.setText(""+currentCommande.getModeLivraison());
            nom.setEnabled(true);
            if (currentCommande.getNomClient().equals("")){
                nom.setText("");
            }else{
                nom.setText(currentCommande.getNomClient());
            }
            DecimalFormat df = new DecimalFormat("0.00");
            prixLivraison();
            prixTotal.setText("Total HT: "+df.format(currentCommande.getPrixTotal()+currentCommande.getPrixLivraison())+"€");
            if (currentCommande.getQtetotal() > 1) {
                qteTotal.setText("Qte total: " + currentCommande.getQtetotal() + " packs");
            } else {
                qteTotal.setText("Qte total: " + currentCommande.getQtetotal() + " pack");
            }
            //20230630 - Calcul du nouveau montant de livraison et on l'affiche
            livraisonTotalHt.setText("Port: "+df.format(currentCommande.getPrixLivraison())+"€");
            prixTotalTtc.setText("Total TTC: "+df.format((currentCommande.getPrixTotal()+currentCommande.getPrixLivraison())*1.2)+"€");
            mAdapter.notifyDataSetChanged();
            //Permet de position la liste à la ligne de l'article ajouté
            recyclerView.getLayoutManager().scrollToPosition(dernierePosition);
        }else{
            date.setText("");
            num.setText("");
            mode.setText("aucun");
            nom.setText("");
            nom.setEnabled(false);
            prixTotal.setText("Total HT: 0,00€");
            livraisonTotalHt.setText("Port: 0,00€");
            qteTotal.setText("Qte total: 0 pack");
            prixTotalTtc.setText("Total TTC: 0,00€");
            dernierePosition = -1;
            mAdapter.notifyDataSetChanged();
        }
    }

    public void validerCommande(View v){
        if (currentCommande != null){
            //new RefreshStockAsyncTask().execute();
            if (!currentCommande.getModeLivraison().equals("aucun")){
                if (currentCommande.getListeProduit().size() > 0){
                    //20230629 - On affiche ici la popup
                    Intent intent = new Intent(ReglementActivity.this, ReglementPopupActivity.class);
                    intent.putExtra("commande", currentCommande);
                    startActivityForResult(intent, 5);
                }else{
                    Toast.makeText(getApplicationContext(), "La commande est vide", Toast.LENGTH_SHORT).show();
                }
            }else{
                Toast.makeText(getApplicationContext(), "Aucun mode de livraison choisi", Toast.LENGTH_SHORT).show();
            }
        }else {
            //jouerSon();
            Toast.makeText(getApplicationContext(), "Vous devez créer une nouvelle commande", Toast.LENGTH_SHORT).show();
        }
    }

    protected boolean isOnline() {
        ConnectivityManager cm = (ConnectivityManager)getSystemService(Context.CONNECTIVITY_SERVICE);
        NetworkInfo netInfo = cm.getActiveNetworkInfo();
        return netInfo != null && netInfo.isConnectedOrConnecting();
    }

    public void nouvelleCommande(View v){

        if (isOnline()){

            if (currentCommande != null){
                DialogInterface.OnClickListener dialogClickListener = new DialogInterface.OnClickListener() {
                    @Override
                    public void onClick(DialogInterface dialog, int which) {
                        switch (which){
                            case DialogInterface.BUTTON_POSITIVE:
                                //Annulation
                                dialog.dismiss();
                                break;

                            case DialogInterface.BUTTON_NEGATIVE:
                                //Terminer
                                //DateFormat dateFormat = new SimpleDateFormat("dd-MM-yyyy");
                                //Date date = new Date();
                                /*newCommande = new Commande();
                                newCommande.setNomClient("");
                                newCommande.setDate(dateFormat.format(date));
                                newCommande.setQtetotal(0);
                                newCommande.setPrixTotal(0);
                                newCommande.setPoids(0);
                                newCommande.setPrixLivraison(0.00);
                                newCommande.setModeLivraison("aucun");*/
                                //new AddCommandeAsyncTask().execute();
                                //20230701 - Recherche d'une commande existante
                                currentCommande = null;
                                saveListeCommandes(); //20230702 - Permet d'enregistrer la commande vide
                                reprendreCommande.setVisibility(View.VISIBLE);
                                txtNumeroCommande.setVisibility(View.VISIBLE);
                                txtNumeroCommande.hasFocus();
                                Toast.makeText(ReglementActivity.this, "Scannez ou saisissez un numéro de commande", Toast.LENGTH_SHORT);
                                dialog.dismiss();
                                break;
                        }
                    }
                };
                AlertDialog.Builder builder = new AlertDialog.Builder(this);
                builder.setTitle("Voulez-vous terminer la commande ?");
                builder.setMessage("Vous ne pourrez plus changer cette commande.");
                builder.setPositiveButton("Annuler", dialogClickListener);
                builder.setNegativeButton("Terminer", dialogClickListener);
                builder.show();
            }else{
                DateFormat dateFormat = new SimpleDateFormat("dd-MM-yyyy");
                Date date = new Date();
                newCommande = new Commande();
                newCommande.setNomClient("");
                newCommande.setDate(dateFormat.format(date));
                newCommande.setQtetotal(0);
                newCommande.setPrixTotal(0.00);
                newCommande.setPoids(0);
                newCommande.setPrixLivraison(0.00);
                newCommande.setModeLivraison("aucun");

                //20230701 - Désactivation des nouvelles commandes
                //new AddCommandeAsyncTask().execute();
            }
        }else{
            //jouerSon();
            Toast.makeText(getApplicationContext(), "Aucune connexion internet", Toast.LENGTH_SHORT).show();
        }
    }

    public static Produit getProduitInCommande(String code128){
        for (Produit pr : currentCommande.getListeProduit()){
            if (pr.getCode128().equals(code128)){
                return pr;
            }
        }
        return null;
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        if (requestCode == 1) {
            if(resultCode == Activity.RESULT_OK){
                Commande newC = data.getParcelableExtra("newC");
                listeCommande.set(selectedTab - 1, newC);
                currentCommande = listeCommande.get(selectedTab - 1);
                mAdapter.setCmd(currentCommande);
                recyclerView.setAdapter(mAdapter);
                afficheCommande();
            }else if (resultCode == Activity.RESULT_CANCELED) {
                if (listeCommande.get(0) == null && listeCommande.get(1) == null && listeCommande.get(2) == null){
                    finish();
                }
                /*else{
                    previousTab.callOnClick();
                }*/
            }
        } else if (requestCode == 2) {
            if(resultCode == Activity.RESULT_OK){
                String choix = data.getStringExtra("choix");
                String choixNom = data.getStringExtra("choixNom");
                Integer posTransporteur = 0;
                switch (choixNom) {
                    case "fr.itsee.season:id/m1":
                        posTransporteur = 0;
                        break;
                    case "fr.itsee.season:id/m4":
                        posTransporteur = 1;
                        break;
                    case "fr.itsee.season:id/m2":
                        posTransporteur = 2;
                        break;
                    case "fr.itsee.season:id/m5":
                        posTransporteur = 3;
                        break;
                    case "fr.itsee.season:id/m3":
                        posTransporteur = 4;
                        break;
                    case "fr.itsee.season:id/m6":
                        posTransporteur = 5;
                        break;
                    case "fr.itsee.season:id/m8":
                        posTransporteur = 6;
                        break;
                    case "fr.itsee.season:id/m7":
                        posTransporteur = 7;
                        break;
                    case "fr.itsee.season:id/m10":
                        posTransporteur = 8;
                        break;
                    case "fr.itsee.season:id/m9":
                        posTransporteur = 9;
                        break;
                    default:
                        break;
                }
                //Attribuer le prix du transporteur
                currentCommande.setFraisDePortClient(listeAllTransporteurs.get(posTransporteur).getPrix());
                currentCommande.setPrixLivraisonMax4(listeAllTransporteurs.get(posTransporteur).getPrixMax4());
                currentCommande.setPrixLivraisonMax8(listeAllTransporteurs.get(posTransporteur).getPrixMax8());
                currentCommande.setPrixLivraisonMax15(listeAllTransporteurs.get(posTransporteur).getPrixMax15());
                currentCommande.setPrixLivraisonMax30(listeAllTransporteurs.get(posTransporteur).getPrixMax30());
                currentCommande.setModeLivraison(listeAllTransporteurs.get(posTransporteur).getNom());

                afficheCommande();

            }else if (resultCode == Activity.RESULT_CANCELED) {

            }
        } else if (requestCode == 3) {
            if(resultCode == Activity.RESULT_OK){
                Produit p = data.getParcelableExtra("produit");
                ajouterProduitCommande(p.getCode128());
            }else if (resultCode == Activity.RESULT_CANCELED) {

            }
        } else if (requestCode == 4) {
            if(resultCode == Activity.RESULT_OK){
                if (currentCommande != null){
                    Produit p = data.getParcelableExtra("produit");
                    ajouterProduitCommande(p.getCode128());
                }else{
                    //jouerSon();
                    Toast.makeText(getApplicationContext(), "Vous devez créer une nouvelle commande", Toast.LENGTH_SHORT).show();
                }

            }else if (resultCode == Activity.RESULT_CANCELED) {

            }
            //20230603 - RETOUR REGLEMENT POPUP
        } else if (requestCode == 5) {
            if(resultCode == Activity.RESULT_OK){
                valider.setEnabled(false);
                valider.setBackground(getDrawable(R.drawable.button_style_disable));
                livraison.setEnabled(false);
                livraison.setBackground(getDrawable(R.drawable.button_style_disable));
                if (currentCommande.getEmailClient() != "" && currentCommande.getTelephoneClient() != "") {
                    Toast.makeText(getApplicationContext(), "Lien de paiement envoyé par email et sms!", Toast.LENGTH_SHORT).show();
                } else if (currentCommande.getTelephoneClient() != "") {
                    Toast.makeText(getApplicationContext(), "Lien de paiement envoyé par sms!", Toast.LENGTH_SHORT).show();
                } else if (currentCommande.getEmailClient() != "") {
                    Toast.makeText(getApplicationContext(), "Lien de paiement envoyé par email!", Toast.LENGTH_SHORT).show();
                }
            } else if (resultCode == Activity.RESULT_CANCELED) {

            }
            //20230603 - RETOUR IMPRESSION COMMANDE
        } else if (requestCode == 100) {
            if(resultCode == Activity.RESULT_OK){
                //20230604 - Si l'impression s'est bien déroulée, alors on efface la commande actuelle
                listeCommande.set(selectedTab - 1, null);
                currentCommande = listeCommande.get(selectedTab - 1);
                mAdapter.setCmd(commandeVide);
                recyclerView.setAdapter(mAdapter);
                afficheCommande();
                //Lancer directement une nouvelle commande
                newC.callOnClick();
            } else if (resultCode == Activity.RESULT_CANCELED) {
                AlertDialog.Builder builder = new AlertDialog.Builder(ReglementActivity.this);
                builder.setCancelable(true);
                builder.setTitle("Echec d'impression");
                String msg = "Souhaitez-vous relancer ?";
                builder.setMessage(msg);
                builder.setPositiveButton("Oui",
                        new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int which) {
                                //Relancer l'impression
                                Intent intent = new Intent(ReglementActivity.this, PrinterActivity.class);
                                intent.putExtra("commande", currentCommande);
                                //startActivity(intent);
                                startActivityForResult(intent, 100);
                                dialog.dismiss();
                            }
                        });
                builder.setNegativeButton("Non",
                        new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int which) {
                                //20230604 - On ne souhaite pas lancer l'impression, alors on efface la commande actuelle
                                listeCommande.set(selectedTab - 1, null);
                                currentCommande = listeCommande.get(selectedTab - 1);
                                mAdapter.setCmd(commandeVide);
                                recyclerView.setAdapter(mAdapter);
                                afficheCommande();
                                //Lancer directement une nouvelle commande
                                newC.callOnClick();
                                dialog.dismiss();
                            }
                        });
                AlertDialog dialog = builder.create();
                dialog.show();
            }
        }

    }

    @Override
    public void onOpened(EMDKManager emdkManager) {
        updateStatus("EMDK open success!");
        this.emdkManager = emdkManager;
        // Acquire the barcode manager resources
        initBarcodeManager();
        // Enumerate scanner devices
        enumerateScannerDevices();
        // Set default scanner
        spinnerScannerDevices.setSelection(defaultIndex);
    }

    @Override
    protected void onResume() {
        super.onResume();
        if (isOnline()) {
            try {
                new GetAllTransporteursAsyncTask().execute();
                new GetAllProduitsAsyncTask().execute();
            }catch (Exception e){
                e.printStackTrace();
            }
        }

        //2023070702 - Afficher la fenêtre charger commande
        if (currentCommande == null || currentCommande.getNum() == null) {
            reprendreCommande.setVisibility(View.VISIBLE);
            txtNumeroCommande.setVisibility(View.VISIBLE);
            txtNumeroCommande.hasFocus();
            Toast.makeText(ReglementActivity.this, "Scannez ou saisissez un numéro de commande", Toast.LENGTH_SHORT);
        }

        // The application is in foreground
        if (emdkManager != null) {
            // Acquire the barcode manager resources
            initBarcodeManager();
            // Enumerate scanner devices
            enumerateScannerDevices();
            // Set selected scanner
            spinnerScannerDevices.setSelection(scannerIndex);
            // Initialize scanner
            initScanner();
        }
    }

    @Override
    protected void onPause() {
        super.onPause();
        // The application is in background
        // Release the barcode manager resources
        deInitScanner();
        deInitBarcodeManager();

    }

    @Override
    public void onClosed() {
        // Release all the resources
        if (emdkManager != null) {
            emdkManager.release();
            emdkManager = null;
        }
        updateStatus("EMDK closed unexpectedly! Please close and restart the application.");
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        saveListeCommandes();
        // Release all the resources
        if (emdkManager != null) {
            emdkManager.release();
            emdkManager = null;
        }
    }

    @Override
    public void onData(ScanDataCollection scanDataCollection) {
        if ((scanDataCollection != null) && (scanDataCollection.getResult() == ScannerResults.SUCCESS)) {
            ArrayList <ScanData> scanData = scanDataCollection.getScanData();
            for(ScanData data : scanData) {
                updateData(data.getData());
            }
        }
    }

    @Override
    public void onStatus(StatusData statusData) {
        ScannerStates state = statusData.getState();
        switch(state) {
            case IDLE:
                statusString = statusData.getFriendlyName()+" is enabled and idle...";
                updateStatus(statusString);
                // set trigger type
                if(bSoftTriggerSelected) {
                    scanner.triggerType = TriggerType.SOFT_ONCE;
                    bSoftTriggerSelected = false;
                } else {
                    scanner.triggerType = TriggerType.HARD;
                }
                // set decoders
                if(bDecoderSettingsChanged) {
                    setDecoders();
                    bDecoderSettingsChanged = false;
                }
                // submit read
                if(!scanner.isReadPending() && !bExtScannerDisconnected) {
                    try {
                        scanner.read();
                    } catch (ScannerException e) {
                        updateStatus(e.getMessage());
                    }
                }
                break;
            case WAITING:
                statusString = "Scanner is waiting for trigger press...";
                updateStatus(statusString);
                break;
            case SCANNING:
                statusString = "Scanning...";
                updateStatus(statusString);
                break;
            case DISABLED:
                statusString = statusData.getFriendlyName()+" is disabled.";
                updateStatus(statusString);
                break;
            case ERROR:
                statusString = "An error has occurred.";
                updateStatus(statusString);
                break;
            default:
                break;
        }
    }

    @Override
    public void onConnectionChange(ScannerInfo scannerInfo, ConnectionState connectionState) {
        String status;
        String scannerName = "";
        String statusExtScanner = connectionState.toString();
        String scannerNameExtScanner = scannerInfo.getFriendlyName();
        if (deviceList.size() != 0) {
            scannerName = deviceList.get(scannerIndex).getFriendlyName();
        }
        if (scannerName.equalsIgnoreCase(scannerNameExtScanner)) {
            switch(connectionState) {
                case CONNECTED:
                    bSoftTriggerSelected = false;
                    synchronized (lock) {
                        initScanner();
                        bExtScannerDisconnected = false;
                    }
                    break;
                case DISCONNECTED:
                    bExtScannerDisconnected = true;
                    synchronized (lock) {
                        deInitScanner();
                    }
                    break;
            }
            status = scannerNameExtScanner + ":" + statusExtScanner;
            updateStatus(status);
        }
        else {
            bExtScannerDisconnected = false;
            status =  statusString + " " + scannerNameExtScanner + ":" + statusExtScanner;
            updateStatus(status);
        }
    }

    private void initScanner() {
        if (scanner == null) {
            if ((deviceList != null) && (deviceList.size() != 0)) {
                if (barcodeManager != null)
                    scanner = barcodeManager.getDevice(deviceList.get(scannerIndex));
            }
            else {
                updateStatus("Failed to get the specified scanner device! Please close and restart the application.");
                return;
            }
            if (scanner != null) {
                scanner.addDataListener(this);
                scanner.addStatusListener(this);
                try {
                    scanner.enable();
                } catch (ScannerException e) {
                    updateStatus(e.getMessage());
                    deInitScanner();
                }
            }else{
                updateStatus("Failed to initialize the scanner device.");
            }
        }
    }

    private void deInitScanner() {
        if (scanner != null) {
            try{
                scanner.disable();
            } catch (Exception e) {
                updateStatus(e.getMessage());
            }

            try {
                scanner.removeDataListener(this);
                scanner.removeStatusListener(this);
            } catch (Exception e) {
                updateStatus(e.getMessage());
            }

            try{
                scanner.release();
            } catch (Exception e) {
                updateStatus(e.getMessage());
            }
            scanner = null;
        }
    }

    private void initBarcodeManager(){
        barcodeManager = (BarcodeManager) emdkManager.getInstance(FEATURE_TYPE.BARCODE);
        if (barcodeManager != null) {
            barcodeManager.addConnectionListener(this);
        }
    }

    private void deInitBarcodeManager(){
        if (emdkManager != null) {
            emdkManager.release(FEATURE_TYPE.BARCODE);
        }
    }

    private void addSpinnerScannerDevicesListener() {
        spinnerScannerDevices.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View arg1, int position, long arg3) {
                if ((scannerIndex != position) || (scanner==null)) {
                    scannerIndex = position;
                    bSoftTriggerSelected = false;
                    bExtScannerDisconnected = false;
                    deInitScanner();
                    initScanner();
                }
            }
            @Override
            public void onNothingSelected(AdapterView<?> arg0) {
            }
        });
    }

    private void enumerateScannerDevices() {
        if (barcodeManager != null) {
            List<String> friendlyNameList = new ArrayList<String>();
            int spinnerIndex = 0;
            deviceList = barcodeManager.getSupportedDevicesInfo();
            if ((deviceList != null) && (deviceList.size() != 0)) {
                Iterator<ScannerInfo> it = deviceList.iterator();
                while(it.hasNext()) {
                    ScannerInfo scnInfo = it.next();
                    friendlyNameList.add(scnInfo.getFriendlyName());
                    if(scnInfo.isDefaultScanner()) {
                        defaultIndex = spinnerIndex;
                    }
                    ++spinnerIndex;
                }
            }
            else {
                updateStatus("Failed to get the list of supported scanner devices! Please close and restart the application.");
            }
            ArrayAdapter<String> spinnerAdapter = new ArrayAdapter<String>(ReglementActivity.this, android.R.layout.simple_spinner_item, friendlyNameList);
            spinnerAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
            spinnerScannerDevices.setAdapter(spinnerAdapter);
        }
    }

    private void setDecoders() {
        if (scanner != null) {
            try {
                ScannerConfig config = scanner.getConfig();
                // Set EAN8
                config.decoderParams.ean8.enabled = checkBoxEAN8.isChecked();
                // Set EAN13
                config.decoderParams.ean13.enabled = checkBoxEAN13.isChecked();
                // Set Code39
                config.decoderParams.code39.enabled= checkBoxCode39.isChecked();
                //Set Code128
                config.decoderParams.code128.enabled = checkBoxCode128.isChecked();
                scanner.setConfig(config);
            } catch (ScannerException e) {
                updateStatus(e.getMessage());
            }
        }
    }

    public void softScan(View view) {
        bSoftTriggerSelected = true;
        cancelRead();
    }

    private void cancelRead(){
        if (scanner != null) {
            if (scanner.isReadPending()) {
                try {
                    scanner.cancelRead();
                } catch (ScannerException e) {
                    updateStatus(e.getMessage());
                }
            }
        }
    }

    private void updateStatus(final String status){
        runOnUiThread(new Runnable() {
            @Override
            public void run() {
                textViewStatus.setText("" + status);
            }
        });
    }

    private void updateData(final String result){
        runOnUiThread(new Runnable() {
            @Override
            public void run() {
                if (((result != null && currentCommande == null) || (result != null && currentCommande.getNum() == null) ) && reprendreCommande.getVisibility() == View.VISIBLE) {
                    if (result.length() == 9) {
                        //Log.d("INFO", "retour:" + result);
                        numeroCommande = result;
                        //Log.d("INFO", "numeroCommande:" + numeroCommande);
                        Toast.makeText(ReglementActivity.this, "Chargement de la commande " + result + "...", Toast.LENGTH_SHORT);
                        new chargerCommandeAsyncTask().execute();
                        //Log.d("INFO", "chargement numeroCommande:" + numeroCommande);
                    } else {
                        Toast.makeText(ReglementActivity.this, "Veuillez scanner un numéro de commande", Toast.LENGTH_SHORT);
                    }
                } else if (result != null && currentCommande != null) {
                    Produit p = getProduitFromCode128(result);
                    if (getCurrentFocus().getClass().getSimpleName().equals("SearchAutoComplete")){
                        if (p != null && currentCommande != null){
                            Intent intent = new Intent(ReglementActivity.this, FicheProduitActivity.class);
                            intent.putExtra("produit", p);
                            startActivityForResult(intent, 3);
                            searchBar.clearFocus();
                        }else if (currentCommande == null){
                            //jouerSon();
                            Toast.makeText(ReglementActivity.this, "Vous devez créer une nouvelle commande", Toast.LENGTH_SHORT).show();
                        }else if(p == null){
                            jouerSon();
                            dernierePosition = -1;
                            mAdapter.notifyDataSetChanged();
                            Toast.makeText(ReglementActivity.this, "Produit inexistant!", Toast.LENGTH_SHORT).show();
                        }
                    }else{
                        if (p != null && currentCommande != null){
                            ajouterProduitCommande(p.getCode128());
                        }else if(p == null){
                            jouerSon();
                            dernierePosition = -1;
                            mAdapter.notifyDataSetChanged();
                            Toast.makeText(ReglementActivity.this, "Produit inexistant!", Toast.LENGTH_SHORT).show();
                        }
                    }
                }
            }
        });
    }

    public Produit getProduitFromCode128(String code128){
        try {
            //Contrôler le stock uniquement lors de l'ajout d'un produit
            //20230706 Modifié uniquement par celui ajouté
            // new RefreshStockAsyncTask().execute();
            int cpt = 0;
            for (Produit p : listeAllProduits){
                if(p.getCode128().equals(code128)){
                    dernierePosition = cpt;
                    //Permet de position la liste à la ligne de l'article ajouté
                    recyclerView.getLayoutManager().scrollToPosition(dernierePosition);
                    new ReglementActivity.RefreshProduitAsyncTask().execute(p); //20230706 uniquement maj stock du produit
                    return p;
                }
                cpt++;
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        return null;
    }

    public void ajouterProduitCommande(String code128){
        int i = 0;
        int max = listeAllProduits.size();
        while ( !listeAllProduits.get(i).getCode128().equals(code128) && i < max - 1){
            i += 1;
        }
        if (i < max){//si le produit existe dans la base de donnees
            int j = 0;
            int nbrProduitCommande = currentCommande.getListeProduit().size();
            Produit p = listeAllProduits.get(i);

            while ( nbrProduitCommande > 0 && !currentCommande.getListeProduit().get(j).getCode128().equals(p.getCode128()) && j < nbrProduitCommande - 1){
                j += 1;
            }

            int qte;
            if (currentCommande.getListeProduit().size() != 0){
                qte = currentCommande.getListeProduit().get(j).getQte();
            }else{
                qte = 0;
            }

            int reste = p.getStock() - qte-1;

            if (j != nbrProduitCommande && nbrProduitCommande != 0 && currentCommande.getListeProduit().get(j).getCode128().equals(p.getCode128())){
                if (reste <= 1 && reste > 0){
                    //jouerSon();
                    currentCommande.getListeProduit().get(j).incQte();
                    Toast.makeText(getApplicationContext(), "stock inférieur à 2!", Toast.LENGTH_SHORT).show();
                }else if(reste == 0){
                    //jouerSon();
                    Toast.makeText(getApplicationContext(), "stock épuisé!", Toast.LENGTH_SHORT).show();
                    currentCommande.getListeProduit().get(j).incQte();
                }else if (reste < -2){ //CHANGEMENT ITSEE 20190630 21:31 changement == -2 vers < -2
                    currentCommande.getListeProduit().get(j).incQte();
                    //jouerSon();
                    Toast.makeText(getApplicationContext(), "stock négatif!", Toast.LENGTH_SHORT).show();
                }
                else{
                    currentCommande.getListeProduit().get(j).incQte();
                }
            }
            else{
                if (reste <= 1 && reste > 0){
                    Produit newProduit = new Produit(p);
                    newProduit.setQte(1);
                    currentCommande.addProduit(newProduit);
                    //jouerSon();
                    Toast.makeText(getApplicationContext(), "Stock inférieur à 2!", Toast.LENGTH_SHORT).show();
                }else if(reste == 0){
                    //jouerSon();
                    Toast.makeText(getApplicationContext(), "Stock épuisé!", Toast.LENGTH_SHORT).show();
                    Produit newProduit = new Produit(p);
                    newProduit.setQte(1);
                    currentCommande.addProduit(newProduit);
                }else if (reste < -2){  // MODIF ITSEE 20190701 16:18 == -2 vers < -2
                    Produit newProduit = new Produit(p);
                    newProduit.setQte(1);
                    currentCommande.addProduit(newProduit);
                    //jouerSon();
                    Toast.makeText(getApplicationContext(), "Stock négatif!", Toast.LENGTH_SHORT).show();
                }
                else{
                    Produit newProduit = new Produit(p);
                    newProduit.setQte(1);
                    currentCommande.addProduit(newProduit);
                }
            }
            mAdapter.notifyDataSetChanged();

            //Permet de position la liste à la ligne de l'article ajouté (ici, si nouveau produit ajouté)
            int k = 0;
            while ( nbrProduitCommande > 0 && !currentCommande.getListeProduit().get(k).getCode128().equals(p.getCode128()) && k < nbrProduitCommande - 1){
                k += 1;
            }
            dernierePosition = k;
            //Permet de position la liste à la ligne de l'article ajouté
            recyclerView.getLayoutManager().scrollToPosition(dernierePosition);
            new RefreshProduitAsyncTask().execute(p); //Désactivé ici, déplacé le 20230706

            afficheCommande();
        }
        else{
            jouerSon();
            dernierePosition = -1;
            mAdapter.notifyDataSetChanged();
            Toast.makeText(getApplicationContext(), "Produit inexistant!", Toast.LENGTH_SHORT).show();
        }
    }


    public void choixModeLivraison(View v){
        if (currentCommande != null){
            Intent intent = new Intent(ReglementActivity.this, ModeLivraisonReglementActivity.class);
            intent.putExtra("commande", currentCommande);
            startActivityForResult(intent, 2);
        }else {
            //jouerSon();
            Toast.makeText(getApplicationContext(), "Vous devez créer une nouvelle commande", Toast.LENGTH_SHORT).show();
        }
    }

    private void checkCommande(final String result){
        runOnUiThread(new Runnable() {
            @Override
            public void run() {
                if (result != null) {
                    if(dataLength ++ > 100) { //Clear the cache after 100 scans
                        textViewData.setText("");
                        dataLength = 0;
                    }
                    textViewData.append(Html.fromHtml(result));
                    textViewData.append("\n");
                    findViewById(R.id.scrollViewData).post(new Runnable()
                    {
                        public void run()
                        {
                            ((ScrollView) findViewById(R.id.scrollViewData)).fullScroll(View.FOCUS_DOWN);
                        }
                    });
                }
            }
        });
    }

    @Override
    public void onCheckedChanged(CompoundButton arg0, boolean arg1) {
        bDecoderSettingsChanged = true;
        cancelRead();
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        int id = item.getItemId();
        if (id == R.id.action_settings) {
            return true;
        }
        return super.onOptionsItemSelected(item);
    }

    //BASE DE DONNES - Charger commande
    private class chargerCommandeAsyncTask extends AsyncTask<String, String, String> {

        //BASE DE DONNES
        private final String BASE_URL = MainActivity.backOfficeURL;

        private int success;
        private Boolean dejaFaite = false;
        private Boolean dejaReglee = false;

        @Override
        protected void onPreExecute() {
            super.onPreExecute();
            //Log.d("INFO","Récupération de la commande '"+numeroCommande+"' en cours...");
            currentCommande = commandeVide;
            nom.setText("Récupération de la commande en cours...");
            //ReglementActivity.currentCommande.setNum(numeroCommande);
        }

        @Override
        protected String doInBackground(String... params) {

            HttpJsonParser httpJsonParser = new HttpJsonParser();
            Map<String, String> httpParams = new HashMap<>();
            httpParams.put("numero_commande", numeroCommande);

            JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                    BASE_URL + "getCommande.php", "GET", httpParams);
            try {
                int success = jsonObject.getInt("success");

                if (success == 1) {
                    JSONObject commande = jsonObject.getJSONArray("data").getJSONObject(0);
                    if (commande.getInt("complete") == 1){
                        dejaFaite = true;
                    }else if (commande.getInt("complete") == 2) {
                        dejaReglee = true;
                        currentCommande.setLien_paiement_envoye(1);
                    }else{
                        currentCommande = new Commande();
                        currentCommande.setNum(commande.getString("numero_commande"));
                        currentCommande.setNomClient(commande.getString("nom_client"));
                        currentCommande.setDate(commande.getString("date_commande"));
                        currentCommande.setQtetotal(0);
                        currentCommande.setPrixTotal(0);
                        currentCommande.setLien_paiement_envoye(0);
                        currentCommande.setModeLivraison(commande.getString("mode_livraison"));
                        currentCommande.setLien_paiement_envoye(0);

                        //recuperation des produits de la commande
                        HttpJsonParser httpJsonParser2 = new HttpJsonParser();
                        Map<String, String> httpParams2 = new HashMap<>();
                        httpParams2.put("num_commande", currentCommande.getNum());
                        JSONObject jsonObject2 = httpJsonParser2.makeHttpRequest(
                                BASE_URL + "listeProduitsCommande.php", "GET", httpParams2);

                        List<Produit> produitList = new ArrayList<>();

                        try {
                            int success2 = jsonObject2.getInt("success");
                            JSONArray produits;
                            if (success2 == 1) {
                                produits = jsonObject2.getJSONArray("data");
                                for (int i = 0; i < produits.length(); i++) {
                                    Produit p = new Produit();
                                    JSONObject produit = produits.getJSONObject(i);
                                    try {
                                        p.setRef(produit.getString("reference"));
                                        p.setColoris(produit.getString("coloris"));
                                        p.setCommandable(produit.getString("commandable"));
                                        p.setCode128(produit.getString("code_128"));
                                        p.setQuantite_pack(produit.getInt("quantite_packs"));
                                        p.setPrix(produit.getDouble("prix"));
                                        if (produit.getString("stock") == "null" || produit.getString("stock") == null) {
                                            p.setStock(0);
                                        } else {
                                            p.setStock(Integer.parseInt(produit.getString("stock")));
                                        }
                                        p.setNumero_de_rayon(produit.getString("numero_de_rayon"));
                                        p.setInformations(produit.getString("informations"));
                                        p.setLien_image(produit.getString("lien_image"));
                                        p.setActif(produit.getInt("actif"));
                                        p.setQte(produit.getInt("quantite"));
                                        p.setPoids(produit.getDouble("poids"));
                                        p.setNbrScanner(0);
                                        produitList.add(p);
                                    }catch (Exception e){
                                        e.printStackTrace();
                                    }
                                }
                                try {
                                    currentCommande.setListeProduit(produitList);
                                }catch (Exception e){
                                    e.printStackTrace();
                                }

                            }
                        } catch (JSONException e) {
                            e.printStackTrace();
                        }
                    }
                } else {
                    currentCommande.setNomClient("");
                }
            } catch (JSONException e) {
                e.printStackTrace();
            }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            AlertDialog.Builder alertDialog = new AlertDialog.Builder(ReglementActivity.this);
            alertDialog.setTitle("Règlement");
            alertDialog.setPositiveButton("OK", new DialogInterface.OnClickListener() {
                public void onClick(DialogInterface dialog, int whichButton) {
                    dialog.dismiss();
                }
            });
            if (dejaReglee || dejaFaite) {
                if (dejaReglee == true) {
                    alertDialog.setMessage("La commande '"+currentCommande.getNum()+"' a déjà été réglée.");
                } else if (dejaFaite == true) {
                    alertDialog.setMessage("La commande '"+currentCommande.getNum()+"' a déjà été contrôlée.");
                } //else {
                //alertDialog.setMessage("Cette commande n'existe pas.");
                //}

                //20230701 - On affiche une commande vide
                //ReglementActivity.currentCommande = commandeVide;

                //jouerSon();
                alertDialog.show();
                currentCommande = commandeVide;
            }
            listeCommande.set(selectedTab - 1, currentCommande);
            Collections.sort(currentCommande.getListeProduit());

            if (currentCommande.getNum() != null) {
                mAdapter.setCmd(currentCommande); //20230702 - Passer la commande à la liste des produits
                afficheCommande();
                txtNumeroCommande.setText("");
                numeroCommande = ""; //Remise à zéro du numéro de commande
                reprendreCommande.setVisibility(View.GONE);
                saveListeCommandes();
                if (currentCommande.getLien_paiement_envoye() == 1) {
                    valider.setEnabled(false);
                    valider.setBackground(getDrawable(R.drawable.button_style_disable));
                    livraison.setEnabled(false);
                    livraison.setBackground(getDrawable(R.drawable.button_style_disable));
                } else {
                    valider.setEnabled(true);
                    valider.setBackground(getDrawable(R.drawable.button_style_valider));
                    livraison.setEnabled(true);
                    livraison.setBackground(getDrawable(R.drawable.button_style));
                }
            } else {
                valider.setEnabled(false);
                valider.setBackground(getDrawable(R.drawable.button_style_disable));
                livraison.setEnabled(false);
                livraison.setBackground(getDrawable(R.drawable.button_style_disable));
                alertDialog.setMessage("Cette commande n'existe pas. Scannez-en une nouvelle!");
                currentCommande = null; //Permet de réinitialiser les commandes
                alertDialog.show();
            }
            txtNumeroCommande.setText("");
            numeroCommande = ""; //Remise à zéro du numéro de commande
            txtNumeroCommande.hasFocus();
        }
    }

    //BASE DE DONNES
    private class GetAllProduitsAsyncTask extends AsyncTask<String, String, String> {

        private final String BASE_URL = MainActivity.backOfficeURL;

        @Override
        protected void onPreExecute() {
            super.onPreExecute();
        }

        @Override
        protected String doInBackground(String... params) {
            HttpJsonParser httpJsonParser = new HttpJsonParser();
            JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                    BASE_URL + "listeProduits.php", "GET", null);
            List<Produit> produitList = new ArrayList<>();
            try {
                int success = jsonObject.getInt("success");
                JSONArray produits;
                if (success == 1) {
                    produits = jsonObject.getJSONArray("data");
                    //Iterate through the response and populate produits list
                    for (int i = 0; i < produits.length(); i++) {
                        Produit p = new Produit();
                        JSONObject produit = produits.getJSONObject(i);

                        try {
                            p.setRef(produit.getString("reference"));
                            p.setColoris(produit.getString("coloris"));
                            p.setCommandable(produit.getString("commandable"));
                            p.setCode128(produit.getString("code_128"));
                            p.setQuantite_pack(produit.getInt("quantite_packs"));
                            p.setPrix(produit.getDouble("prix"));
                            if (produit.getString("stock") == "null" || produit.getString("stock") == null) {
                                p.setStock(0);
                            } else {
                                p.setStock(Integer.parseInt(produit.getString("stock")));
                            }
                            p.setNumero_de_rayon(produit.getString("numero_de_rayon"));
                            p.setInformations(produit.getString("informations"));
                            p.setLien_image(produit.getString("lien_image"));
                            p.setActif(produit.getInt("actif"));
                            p.setPoids(produit.getDouble("poids"));
                            p.setQte(1);
                            produitList.add(p);

                        }catch (Exception e){
                            e.printStackTrace();
                        }

                    }
                    ReglementActivity.listeAllProduits = produitList;
                }
            } catch (JSONException e) {
                e.printStackTrace();
            }catch (Exception e){
                e.printStackTrace();
            }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            txtChargement.setVisibility(View.INVISIBLE);
            txtNumeroCommande.setVisibility(View.VISIBLE);
        }
    }


    private class UpdateCommandeAsyncTask extends AsyncTask<String, String, String> {

        private final String BASE_URL = MainActivity.backOfficeURL;

        private int success;

        @Override
        protected void onPreExecute() {
            super.onPreExecute();

        }

        @Override
        protected String doInBackground(String... params) {
            HttpJsonParser httpJsonParser1 = new HttpJsonParser();
            Map<String, String> httpParams1 = new HashMap<>();
            httpParams1.put("num_commande", currentCommande.getNum());

            JSONObject jsonObject1 = httpJsonParser1.makeHttpRequest(
                    BASE_URL + "viderCommande.php", "POST", httpParams1);
            try {
                success = jsonObject1.getInt("success");
            } catch (JSONException e) {
                e.printStackTrace();
            }

            HttpJsonParser httpJsonParser = new HttpJsonParser();
            Map<String, String> httpParams = new HashMap<>();
            httpParams.put("num_commande", currentCommande.getNum());

            for(Produit p : currentCommande.getListeProduit()){

                httpParams.put("code128_produit", p.getCode128());
                httpParams.put("quantite", String.valueOf(p.getQte()));
                httpParams.put("prix", String.valueOf(p.getPrix()));
                httpParams.put("quantite_pack", String.valueOf(p.getQuantite_pack()));

                JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                        BASE_URL + "ajoutProduitCommande.php", "POST", httpParams);
                try {
                    success = jsonObject.getInt("success");
                } catch (JSONException e) {

                    e.printStackTrace();
                }

            }

            HttpJsonParser httpJsonParser2 = new HttpJsonParser();
            Map<String, String> httpParams2 = new HashMap<>();

            httpParams2.put("numero_commande", currentCommande.getNum());
            httpParams2.put("nom_client", currentCommande.getNomClient());
            httpParams2.put("mode_livraison", currentCommande.getModeLivraison());
            JSONObject jsonObject2 = httpJsonParser2.makeHttpRequest(
                    BASE_URL + "updateCommande.php", "POST", httpParams2);
            try {
                success = jsonObject2.getInt("success");
            } catch (JSONException e) {
                e.printStackTrace();
            }

            if (ancienNbrColis != currentCommande.getNbrColis()) {
                ancienNbrColis = currentCommande.getNbrColis();
                //20230702 - Mise à jour de la liste des colis
                HttpJsonParser httpJsonParser3 = new HttpJsonParser();
                Map<String, String> httpParams3 = new HashMap<>();

                httpParams3.put("numero_commande", currentCommande.getNum());
                httpParams3.put("nombre_colis", "" + currentCommande.getNbrColis());
                httpParams3.put("nom_client", ""+currentCommande.getNomClient());
                JSONObject jsonObject3 = httpJsonParser3.makeHttpRequest(
                        BASE_URL + "updateCommandeColis.php", "POST", httpParams3);
                try {
                    success = jsonObject3.getInt("success");
                } catch (JSONException e) {
                    e.printStackTrace();
                }
            }


            return null;
        }
    }

    public static class UpdateCommandeJSONAsyncTask extends AsyncTask<String, String, String> {

        private final String BASE_URL = MainActivity.backOfficeURL;
        private int success;

        @Override
        protected void onPreExecute() {
            super.onPreExecute();
        }

        @Override
        protected String doInBackground(String... params) {
            if (currentCommande != null && currentCommande.getNum() != "") {
                try {
                    Gson gson = new Gson();
                    String json_produits = "";
                    try {
                        json_produits = gson.toJson(currentCommande.getListeProduit());
                    } catch (Exception e) {
                        return "Impossible de mettre à jour la commande!";
                    }
                    HttpJsonParser httpJsonParser1 = new HttpJsonParser();
                    Map<String, String> httpParams1 = new HashMap<>();
                    httpParams1.put("numero_commande", ""+currentCommande.getNum());
                    httpParams1.put("nom_client", ""+currentCommande.getNomClient());
                    httpParams1.put("nom_transporteur", ""+currentCommande.getModeLivraison());
                    httpParams1.put("date", ""+currentCommande.getDate());
                    httpParams1.put("poids_commande", ""+currentCommande.getPoids());
                    httpParams1.put("total_fdp_ht", ""+currentCommande.getPrixLivraison());
                    httpParams1.put("qte_produits", ""+currentCommande.getQtetotal());
                    httpParams1.put("liste_produits", ""+json_produits);
                    httpParams1.put("total_produits", ""+(currentCommande.getPrixTotal()));
                    JSONObject jsonObject1 = httpJsonParser1.makeHttpRequest(
                            BASE_URL + "updateCommandeJSON.php", "POST", httpParams1);
                    success = jsonObject1.getInt("success");
                    //Si maj effectué
                    if (success == 1) {
                        //Mis à jour
                    }
                    jsonObject1 = null;
                } catch (JSONException e) {
                    return "Impossible de mettre à jour la commande!";
                }
            }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
        }
    }

    static Integer poidsLivraison() {
        if (currentCommande != null) {
            int totalPoidsLivraison = 0;
            //On parcours chaque poids de produit * qteParPack * quantite
            for (Produit p : currentCommande.getListeProduit()) {
                totalPoidsLivraison += (p.getPoids()*p.getQuantite_pack()*p.getQte());
            }
            //Log.d("INFO","poids:"+totalPoidsLivraison);
            currentCommande.setPoids(totalPoidsLivraison);
            return totalPoidsLivraison;
        } else {
            return 0;
        }
    }

    static void prixLivraison() {
        Integer cptColis = 0;
        Double prixTotalLivraison = 0.00;
        int poidsTotalLivraison = poidsLivraison();
        while (poidsTotalLivraison > 30000) {
            //Dans le cas ou le poids est supérieur à 30kg, c'est a dire que l'on choisi le prix poids max à 30 puis on continu
            prixTotalLivraison += currentCommande.getPrixLivraisonMax30();
            poidsTotalLivraison -= 30000;
            cptColis++;
        }
        //Puis une fois que le prix est égal à 30 ou < on ajoute le montant de livraison correspondant
        if (poidsTotalLivraison > 15000) {
            prixTotalLivraison += currentCommande.getPrixLivraisonMax30();
        } else if (poidsTotalLivraison > 8000) {
            prixTotalLivraison += currentCommande.getPrixLivraisonMax15();
        } else if (poidsTotalLivraison > 4000) {
            prixTotalLivraison += currentCommande.getPrixLivraisonMax8();
        } else {
            prixTotalLivraison += currentCommande.getPrixLivraisonMax4();
        }
        cptColis++;
        //20230702 - Enregistrement du nombre de colis
        currentCommande.setNbrColis(cptColis);

        //Log.d("INFO","prixlivraison:"+prixTotalLivraison+" poids:"+poidsLivraison());
        //Enregistrement du prix de livraison
        currentCommande.setPrixLivraison(prixTotalLivraison);
        //return prixTotalLivraison;
    }

    private class DestockageProduitAsyncTask extends AsyncTask<String, String, String> {

        private final String BASE_URL = MainActivity.backOfficeURL;

        private int success;

        ProgressDialog waiting;


        @Override
        protected void onPreExecute() {
            super.onPreExecute();

            waiting = new ProgressDialog(ReglementActivity.this);
            waiting.setTitle("Impression en cours ...");
            waiting.setMessage("Veuillez patienter");
            waiting.show();

            //new UpdateCommandeAsyncTask().execute();
            new UpdateCommandeJSONAsyncTask().execute();

            //Impression à la fin
        }

        @Override
        protected String doInBackground(String... params) {

            if (currentCommande != null) {
                HttpJsonParser httpJsonParser = new HttpJsonParser();
                Map<String, String> httpParams = new HashMap<>();

                //On forme le json à envoyer
                for(Produit p : currentCommande.getListeProduit()){

                    httpParams.put("code128_produit", p.getCode128());
                    httpParams.put("quantite", String.valueOf(p.getQte()));

                    JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                            BASE_URL + "destockageProduit.php", "POST", httpParams);
                    try {
                        success = jsonObject.getInt("success");
                    } catch (JSONException e) {
                        e.printStackTrace();
                    }
                }

            }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            //waiting.dismiss();

            /*waiting = new ProgressDialog(ReglementActivity.this);
            waiting.setTitle("Enregistrement des produits de la commande");
            waiting.setMessage("Veuillez patienter");
            waiting.show();
*/
            //Lance l'impression en appelant la classe PrinterActivity remplacé par PrinterAsync
            Intent intent = new Intent(ReglementActivity.this, PrinterActivity.class);
            intent.putExtra("commande", currentCommande);
            //startActivity(intent);
            startActivityForResult(intent, 100);

            if (!ReglementActivity.this.isFinishing() && waiting != null) {
                waiting.dismiss();
            }

            //20230604 - DEPLACE DANS LE RETOUR DE L'IMPRESSION DE LA COMMANDE
            //SI L'IMPRESSION NE S'EST PAS PASSE, ALORS ON NE FAIT RIEN
            /*listeCommande.set(selectedTab - 1, null);
            currentCommande = listeCommande.get(selectedTab - 1);
            mAdapter.setCmd(commandeVide);
            recyclerView.setAdapter(mAdapter);
            afficheCommande();
            //Lancer directement une nouvelle commande
            newC.callOnClick();*/
        }
    }

    private class RefreshProduitAsyncTask extends AsyncTask<Produit, String, String> {

        //BASE DE DONNES
        private final String BASE_URL = MainActivity.backOfficeURL;

        private int success;

        @Override
        protected String doInBackground(Produit... produits) {
            Produit p = produits[0];

            HttpJsonParser httpJsonParser2 = new HttpJsonParser();
            Map<String, String> httpParams2 = new HashMap<>();

            httpParams2.put("code_128", p.getCode128());
            JSONObject jsonObject2 = httpJsonParser2.makeHttpRequest(
                    BASE_URL + "getStockProduit.php", "GET", httpParams2);

            try {
                success = jsonObject2.getInt("success");
                if (success == 1){
                    JSONObject produit = jsonObject2.getJSONArray("data").getJSONObject(0);
                    if (produit.getString("stock") == "null" || produit.getString("stock") == null) {
                        p.setStock(0);
                    } else {
                        p.setStock(Integer.parseInt(produit.getString("stock")));
                    }
                }

            } catch (JSONException e) {
                e.printStackTrace();
            }

            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            mAdapter.notifyDataSetChanged();
        }
    }



    /*private class RefreshStockAsyncTask extends AsyncTask<String, String, String> {

        //BASE DE DONNES
        private final String BASE_URL = MainActivity.backOfficeURL;

        private int success;

        ProgressDialog waiting;

        @Override
        protected void onPreExecute() {
            super.onPreExecute();

            //waiting = new ProgressDialog(ReglementActivity.this);
            //waiting.setTitle("Contrôle du stock des produits en cours...");
            //waiting.setMessage("Veuillez patienter");
            //waiting.show();
        }

        @Override
        protected String doInBackground(String... params) {
            try {
                if (currentCommande != null) {
                    for (Produit p : currentCommande.getListeProduit()) {
                        HttpJsonParser httpJsonParser2 = new HttpJsonParser();
                        Map<String, String> httpParams2 = new HashMap<>();

                        httpParams2.put("code_128", p.getCode128());
                        JSONObject jsonObject2 = httpJsonParser2.makeHttpRequest(
                                BASE_URL + "getStockProduit.php", "GET", httpParams2);

                        try {
                            success = jsonObject2.getInt("success");
                            if (success == 1) {
                                JSONObject produit = jsonObject2.getJSONArray("data").getJSONObject(0);
                                p.setStock(Integer.parseInt(produit.getString("stock")));
                            }

                        } catch (JSONException e) {
                            e.printStackTrace();
                        }
                    }
                }
            }catch (Exception e){
                e.printStackTrace();
            }

            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            mAdapter.notifyDataSetChanged();
            //waiting.dismiss();
        }
    }*/
    private class AddCommandeAsyncTask extends AsyncTask<String, String, String> {

        //BASE DE DONNES
        private final String BASE_URL = MainActivity.backOfficeURL;
        private int success;
        private ProgressDialog waiting;

        @Override
        protected void onPreExecute() {
            super.onPreExecute();

            waiting = new ProgressDialog(ReglementActivity.this);
            waiting.setTitle("Création de la commande en cours...");
            waiting.setMessage("Veuillez patienter");
            waiting.show();

        }

        @Override
        protected String doInBackground(String... params) {

            DateFormat dateFormatForNumCommande = new SimpleDateFormat("yyMMdd");
            Date date = new Date();

            HttpJsonParser httpJsonParser = new HttpJsonParser();
            Map<String, String> httpParams = new HashMap<>();
            httpParams.put("date", newCommande.getDate());
            JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                    BASE_URL + "listeCommandeDate.php", "GET", httpParams);
            int nbrCommandeParDate = 0;
            try {
                int success = jsonObject.getInt("success");
                int nbrCommandesAjd;

                if (success == 1) {
                    nbrCommandesAjd = jsonObject.getInt("data");
                    nbrCommandeParDate = nbrCommandesAjd;
                }
            } catch (JSONException e) {
                e.printStackTrace();
            }

            newCommande.setNum(dateFormatForNumCommande.format(date) + String.format("%03d", (nbrCommandeParDate + 1)));

            HttpJsonParser httpJsonParser2 = new HttpJsonParser();
            Map<String, String> httpParams2 = new HashMap<>();
            //Populating request parameters
            httpParams2.put("numero_commande", newCommande.getNum());
            httpParams2.put("nom_client", "");
            httpParams2.put("date_commande", newCommande.getDate());
            httpParams2.put("zone", "0");
            httpParams2.put("complete", "0");
            httpParams2.put("mode_livraison", newCommande.getModeLivraison());

            JSONObject jsonObject2 = httpJsonParser2.makeHttpRequest(
                    BASE_URL + "ajouterCommande.php", "POST", httpParams2);
            try {
                success = jsonObject2.getInt("success");
            } catch (JSONException e) {
                e.printStackTrace();
            }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            if (!ReglementActivity.this.isFinishing() && waiting != null) {
                waiting.dismiss();
            }
            listeCommande.set(selectedTab - 1, newCommande);
            currentCommande = listeCommande.get(selectedTab - 1);
            mAdapter.setCmd(currentCommande);
            recyclerView.setAdapter(mAdapter);
            afficheCommande();

        }
    }

    private class VerifStockAsyncTask extends AsyncTask<String, String, String> {

        private final String BASE_URL = MainActivity.backOfficeURL;
        private int success;

        ProgressDialog waiting;

        @Override
        protected void onPreExecute() {
            super.onPreExecute();

            waiting = new ProgressDialog(ReglementActivity.this);
            waiting.setTitle("Impression en cours...");
            waiting.setMessage("Veuillez patienter");
            waiting.show();
        }

        @Override
        protected String doInBackground(String... params) {
            listeRupture = new ArrayList<>();

            for (Produit p : currentCommande.getListeProduit()){
                HttpJsonParser httpJsonParser2 = new HttpJsonParser();
                Map<String, String> httpParams2 = new HashMap<>();

                httpParams2.put("code_128", p.getCode128());
                JSONObject jsonObject2 = httpJsonParser2.makeHttpRequest(
                        BASE_URL + "getStockProduit.php", "GET", httpParams2);

                try {
                    success = jsonObject2.getInt("success");
                    if (success == 1){
                        JSONObject produit = jsonObject2.getJSONArray("data").getJSONObject(0);
                        if (produit.getString("stock") == "null" || produit.getString("stock") == null) {
                            p.setStock(0);
                        } else {
                            p.setStock(Integer.parseInt(produit.getString("stock")));
                        }
                    }

                } catch (JSONException e) {
                    e.printStackTrace();
                }
                if (p.getStock() - p.getQte() < -1){
                    listeRupture.add(p);
                }
            }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            if (listeRupture.size() == 0){
                //Lancement de l'application
                //Lancement du déstockage
                new DestockageProduitAsyncTask().execute();
            }else{
                AlertDialog.Builder builder = new AlertDialog.Builder(ReglementActivity.this);
                builder.setCancelable(true);
                builder.setTitle("Rupture de stock");
                String msg = "Les produits suivants ont un stock insuffisant, vous devez réduire leurs quantités ou les enlever de la commande.\n\n";
                for (Produit p : listeRupture){
                    if (p.getStock() > 1) {
                        msg += p.getCode128() + " (" + p.getStock() + " restants)\n";
                    } else {
                        msg += p.getCode128() + " (" + p.getStock() + " restant)\n";
                    }
                }
                builder.setMessage(msg);
                builder.setPositiveButton("OK",
                        new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int which) {
                                dialog.dismiss();
                            }
                        });
                AlertDialog dialog = builder.create();
                dialog.show();
            }
            if (!ReglementActivity.this.isFinishing() && waiting != null) {
                waiting.dismiss();
            }
        }
    }

    private class GetAllTransporteursAsyncTask extends AsyncTask<String, String, String> {

        private final String BASE_URL = MainActivity.backOfficeURL;


        @Override
        protected void onPreExecute() {
            super.onPreExecute();

        }

        @Override
        protected String doInBackground(String... params) {
            HttpJsonParser httpJsonParser = new HttpJsonParser();
            JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                    BASE_URL + "listeTransporteurs.php", "GET", null);
            List<Transporteur> transporteursList = new ArrayList<>();
            try {
                int success = jsonObject.getInt("success");
                JSONArray transporteurs;
                if (success == 1) {
                    transporteurs = jsonObject.getJSONArray("data");
                    for (int i = 0; i < transporteurs.length(); i++) {
                        Transporteur t = new Transporteur();
                        JSONObject transporteur = transporteurs.getJSONObject(i);
                        try {
                            t.setNom(transporteur.getString("nom"));
                            t.setPrix(transporteur.getDouble("prix"));
                            t.setPrixMax4(transporteur.getDouble("prixMax4"));
                            t.setPrixMax8(transporteur.getDouble("prixMax8"));
                            t.setPrixMax15(transporteur.getDouble("prixMax15"));
                            t.setPrixMax30(transporteur.getDouble("prixMax30"));
                            transporteursList.add(t);
                        }catch (Exception e){
                            e.printStackTrace();
                        }
                    }
                    ReglementActivity.listeAllTransporteurs = transporteursList;
                }
            } catch (JSONException e) {
                e.printStackTrace();
            }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
        }
    }

    void jouerSon() {
        mediaPlayer = new MediaPlayer();
        try {
            AssetFileDescriptor afd = null;
            afd = getResources().getAssets().openFd("notification.mp3");
            /*if (filename != "erreurProduit_v2.mp3") {
                mediaPlayer.setVolume(0.2f,0.2f);
            } else {*/
            mediaPlayer.setVolume(1.0f,1.0f);
            //}
            mediaPlayer.setDataSource(afd.getFileDescriptor(), afd.getStartOffset(), afd.getLength());
            mediaPlayer.prepareAsync();
        } catch (IllegalArgumentException e) {
            e.printStackTrace();
        } catch (IllegalStateException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
        //Lancer en mode asynchrone pour continuer en permanence
        mediaPlayer.setOnPreparedListener(mp -> mp.start());
        //Release après lecture
        mediaPlayer.setOnCompletionListener(mp -> {
            if (mp != null) {
                mp.release();
            }
        });
    }

    public void imprimerCommande(View v){
        if (currentCommande != null){
            //new RefreshStockAsyncTask().execute();
            if (!currentCommande.getModeLivraison().equals("aucun")){
                if (currentCommande.getListeProduit().size() > 0){
                    new VerifStockAsyncTask().execute();
                }else{
                    Toast.makeText(getApplicationContext(), "La commande est vide", Toast.LENGTH_SHORT).show();
                }
            }else{
                Toast.makeText(getApplicationContext(), "Aucun mode de livraison choisi", Toast.LENGTH_SHORT).show();
            }
        }else {
            //jouerSon();
            Toast.makeText(getApplicationContext(), "Vous devez créer une nouvelle commande", Toast.LENGTH_SHORT).show();
        }
    }

    public void reprendreCommandeButton(View v){

        if (isOnline()){
            AlertDialog.Builder builder = new AlertDialog.Builder(ReglementActivity.this);
            if (numeroCommande == "" || numeroCommande.length() != 9) {
                builder.setCancelable(true);
                builder.setTitle("Règlement");
                String msg = "Veuillez saisir un numéro de commande";
                builder.setMessage(msg);
                builder.setPositiveButton("Ok",
                        new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int which) {
                                dialog.dismiss();
                            }
                        });
                AlertDialog dialog = builder.create();
                dialog.show();
            } else {
                Toast.makeText(ReglementActivity.this, "Veuillez saisir un numéro de commande", Toast.LENGTH_SHORT);
                //reprendreCommandeButton.setVisibility(View.INVISIBLE);
                //Log.d("INFO","numeroCommande:"+numeroCommande);
            }
        }else{
            Toast.makeText(getApplicationContext(), "Aucune connexion internet", Toast.LENGTH_SHORT).show();
        }
    }

}