package fr.itsee.season;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.content.res.AssetFileDescriptor;
import android.media.MediaPlayer;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.AsyncTask;
import android.os.Bundle;

import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.text.method.ScrollingMovementMethod;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ArrayAdapter;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import com.symbol.emdk.EMDKManager;
import com.symbol.emdk.EMDKResults;
import com.symbol.emdk.EMDKManager.EMDKListener;
import com.symbol.emdk.EMDKManager.FEATURE_TYPE;
import com.symbol.emdk.barcode.BarcodeManager;
import com.symbol.emdk.barcode.BarcodeManager.ConnectionState;
import com.symbol.emdk.barcode.BarcodeManager.ScannerConnectionListener;
import com.symbol.emdk.barcode.ScanDataCollection;
import com.symbol.emdk.barcode.Scanner;
import com.symbol.emdk.barcode.ScannerConfig;
import com.symbol.emdk.barcode.ScannerException;
import com.symbol.emdk.barcode.ScannerInfo;
import com.symbol.emdk.barcode.ScannerResults;
import com.symbol.emdk.barcode.ScanDataCollection.ScanData;
import com.symbol.emdk.barcode.Scanner.DataListener;
import com.symbol.emdk.barcode.Scanner.StatusListener;
import com.symbol.emdk.barcode.Scanner.TriggerType;
import com.symbol.emdk.barcode.StatusData.ScannerStates;
import com.symbol.emdk.barcode.StatusData;

public class ReserveActivity extends AppCompatActivity implements EMDKListener, DataListener, StatusListener, ScannerConnectionListener, CompoundButton.OnCheckedChangeListener {
    /*public class CommandesActivity extends AppCompatActivity {*/

    private static List<Produit> listeAllProduits;

    //Partie Scanner
    private EMDKManager emdkManager = null;
    private BarcodeManager barcodeManager = null;
    private Scanner scanner = null;

    private TextView textViewData = null;
    private TextView textViewStatus = null;

    private TextView txtAncienNumeroDeRayon,txtChargement;
    private EditText editTxtCode128, editTxtNumRayon;
    private Button buttonModifier;
    private String ancienNumeroRayon;

    private CheckBox checkBoxEAN8 = null;
    private CheckBox checkBoxEAN13= null;
    private CheckBox checkBoxCode39= null;
    private CheckBox checkBoxCode128= null;

    private Spinner spinnerScannerDevices= null;

    private List<ScannerInfo> deviceList = null;


    private int scannerIndex = 0; // Keep the selected scanner
    private int defaultIndex = 0; // Keep the default scanner
    private final int dataLength = 0;
    private String statusString = "";

    private boolean bSoftTriggerSelected = false;
    private boolean bDecoderSettingsChanged = false;
    private boolean bExtScannerDisconnected = false;
    private final Object lock = new Object();

    //Son
    private MediaPlayer mediaPlayer;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_reserve);

        try {
            new GetAllProduitsAsyncTask().execute();
        }catch (Exception e){
            e.printStackTrace();
        }

        txtAncienNumeroDeRayon = findViewById(R.id.txtAncienNumeroDeRayon);
        txtChargement = findViewById(R.id.txtChargement);
        editTxtCode128 = findViewById(R.id.editTxtCode128);
        editTxtCode128.requestFocus();
        editTxtNumRayon = findViewById(R.id.editTxtNumRayon);
        buttonModifier = findViewById(R.id.buttonModifier);

        //Permet de saisir manuellement les informations
        editTxtCode128.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
              editTxtNumRayon.setVisibility(View.VISIBLE);
              buttonModifier.setVisibility(View.VISIBLE);
            }
        });

        textViewData = findViewById(R.id.textViewData);
        textViewStatus = findViewById(R.id.textViewStatus);
        checkBoxEAN8 = findViewById(R.id.checkBoxEAN8);
        checkBoxEAN13 = findViewById(R.id.checkBoxEAN13);
        checkBoxCode39 = findViewById(R.id.checkBoxCode39);
        checkBoxCode128 = findViewById(R.id.checkBoxCode128);
        spinnerScannerDevices = findViewById(R.id.spinnerScannerDevices);

        RecyclerView.LayoutManager mLayoutManager = new LinearLayoutManager(getApplicationContext());

        deviceList = new ArrayList<ScannerInfo>();

        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_NOSENSOR);

        EMDKResults results = EMDKManager.getEMDKManager(getApplicationContext(), this);
        if (results.statusCode != EMDKResults.STATUS_CODE.SUCCESS) {
            updateStatus("EMDKManager object request failed!");
            return;
        }

        checkBoxEAN8.setOnCheckedChangeListener(this);
        checkBoxEAN13.setOnCheckedChangeListener(this);
        checkBoxCode39.setOnCheckedChangeListener(this);
        checkBoxCode128.setOnCheckedChangeListener(this);

        addSpinnerScannerDevicesListener();
        textViewData.setSelected(true);
        textViewData.setMovementMethod(new ScrollingMovementMethod());

    }

    @Override
    protected void onStop() {
        super.onStop();
    }

    protected boolean isOnline() {
        ConnectivityManager cm = (ConnectivityManager)getSystemService(Context.CONNECTIVITY_SERVICE);
        NetworkInfo netInfo = cm.getActiveNetworkInfo();
        return netInfo != null && netInfo.isConnectedOrConnecting();
    }

    public static Produit getProduitCode128(String code128){
        for (Produit pr : listeAllProduits){
            if (pr.getCode128().equals(code128)){
                return pr;
            }
        }
        return null;
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data) {
        if (requestCode == 1) {
            if(resultCode == Activity.RESULT_OK){
            }else if (resultCode == Activity.RESULT_CANCELED) {
            }
        }

    }

    @Override
    public void onOpened(EMDKManager emdkManager) {
        updateStatus("EMDK open success!");
        this.emdkManager = emdkManager;
        // Acquire the barcode manager resources
        initBarcodeManager();
        // Enumerate scanner devices
        enumerateScannerDevices();
        // Set default scanner
        spinnerScannerDevices.setSelection(defaultIndex);
    }

    @Override
    protected void onResume() {
        super.onResume();
        if (isOnline()) {
            try {
                new GetAllProduitsAsyncTask().execute();
            }catch (Exception e){
                e.printStackTrace();
            }
        }
        // The application is in foreground
        if (emdkManager != null) {
            // Acquire the barcode manager resources
            initBarcodeManager();
            // Enumerate scanner devices
            enumerateScannerDevices();
            // Set selected scanner
            spinnerScannerDevices.setSelection(scannerIndex);
            // Initialize scanner
            initScanner();
        }
    }

    @Override
    protected void onPause() {
        super.onPause();
        // The application is in background
        // Release the barcode manager resources
        deInitScanner();
        deInitBarcodeManager();
    }

    @Override
    public void onClosed() {
        // Release all the resources
        if (emdkManager != null) {
            emdkManager.release();
            emdkManager = null;
        }
        updateStatus("EMDK closed unexpectedly! Please close and restart the application.");
    }

    @Override
    protected void onDestroy() {
        super.onDestroy();
        // Release all the resources
        if (emdkManager != null) {
            emdkManager.release();
            emdkManager = null;
        }
    }

    @Override
    public void onData(ScanDataCollection scanDataCollection) {
        if ((scanDataCollection != null) && (scanDataCollection.getResult() == ScannerResults.SUCCESS)) {
            ArrayList <ScanData> scanData = scanDataCollection.getScanData();
            for(ScanData data : scanData) {
                updateData(data.getData());
            }
        }
    }

    @Override
    public void onStatus(StatusData statusData) {
        ScannerStates state = statusData.getState();
        switch(state) {
            case IDLE:
                statusString = statusData.getFriendlyName()+" is enabled and idle...";
                updateStatus(statusString);
                // set trigger type
                if(bSoftTriggerSelected) {
                    scanner.triggerType = TriggerType.SOFT_ONCE;
                    bSoftTriggerSelected = false;
                } else {
                    scanner.triggerType = TriggerType.HARD;
                }
                // set decoders
                if(bDecoderSettingsChanged) {
                    setDecoders();
                    bDecoderSettingsChanged = false;
                }
                // submit read
                if(!scanner.isReadPending() && !bExtScannerDisconnected) {
                    try {
                        scanner.read();
                    } catch (ScannerException e) {
                        updateStatus(e.getMessage());
                    }
                }
                break;
            case WAITING:
                statusString = "Scanner is waiting for trigger press...";
                updateStatus(statusString);
                break;
            case SCANNING:
                statusString = "Scanning...";
                updateStatus(statusString);
                break;
            case DISABLED:
                statusString = statusData.getFriendlyName()+" is disabled.";
                updateStatus(statusString);
                break;
            case ERROR:
                statusString = "An error has occurred.";
                updateStatus(statusString);
                break;
            default:
                break;
        }
    }

    @Override
    public void onConnectionChange(ScannerInfo scannerInfo, ConnectionState connectionState) {
        String status;
        String scannerName = "";
        String statusExtScanner = connectionState.toString();
        String scannerNameExtScanner = scannerInfo.getFriendlyName();
        if (deviceList.size() != 0) {
            scannerName = deviceList.get(scannerIndex).getFriendlyName();
        }
        if (scannerName.equalsIgnoreCase(scannerNameExtScanner)) {
            switch(connectionState) {
                case CONNECTED:
                    bSoftTriggerSelected = false;
                    synchronized (lock) {
                        initScanner();
                        bExtScannerDisconnected = false;
                    }
                    break;
                case DISCONNECTED:
                    bExtScannerDisconnected = true;
                    synchronized (lock) {
                        deInitScanner();
                    }
                    break;
            }
            status = scannerNameExtScanner + ":" + statusExtScanner;
            updateStatus(status);
        }
        else {
            bExtScannerDisconnected = false;
            status =  statusString + " " + scannerNameExtScanner + ":" + statusExtScanner;
            updateStatus(status);
        }
    }

    private void initScanner() {
        if (scanner == null) {
            if ((deviceList != null) && (deviceList.size() != 0)) {
                if (barcodeManager != null)
                    scanner = barcodeManager.getDevice(deviceList.get(scannerIndex));
            }
            else {
                updateStatus("Failed to get the specified scanner device! Please close and restart the application.");
                return;
            }
            if (scanner != null) {
                scanner.addDataListener(this);
                scanner.addStatusListener(this);
                try {
                    scanner.enable();
                } catch (ScannerException e) {
                    updateStatus(e.getMessage());
                    deInitScanner();
                }
            }else{
                updateStatus("Failed to initialize the scanner device.");
            }
        }
    }

    private void deInitScanner() {
        if (scanner != null) {
            try{
                scanner.disable();
            } catch (Exception e) {
                updateStatus(e.getMessage());
            }
            try {
                scanner.removeDataListener(this);
                scanner.removeStatusListener(this);
            } catch (Exception e) {
                updateStatus(e.getMessage());
            }
            try{
                scanner.release();
            } catch (Exception e) {
                updateStatus(e.getMessage());
            }
            scanner = null;
        }
    }

    private void initBarcodeManager(){
        barcodeManager = (BarcodeManager) emdkManager.getInstance(FEATURE_TYPE.BARCODE);
        if (barcodeManager != null) {
            barcodeManager.addConnectionListener(this);
        }
    }

    private void deInitBarcodeManager(){
        if (emdkManager != null) {
            emdkManager.release(FEATURE_TYPE.BARCODE);
        }
    }

    private void addSpinnerScannerDevicesListener() {
        spinnerScannerDevices.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {
            @Override
            public void onItemSelected(AdapterView<?> parent, View arg1, int position, long arg3) {
                if ((scannerIndex != position) || (scanner==null)) {
                    scannerIndex = position;
                    bSoftTriggerSelected = false;
                    bExtScannerDisconnected = false;
                    deInitScanner();
                    initScanner();
                }
            }
            @Override
            public void onNothingSelected(AdapterView<?> arg0) {
            }
        });
    }

    private void enumerateScannerDevices() {
        if (barcodeManager != null) {
            List<String> friendlyNameList = new ArrayList<String>();
            int spinnerIndex = 0;
            deviceList = barcodeManager.getSupportedDevicesInfo();
            if ((deviceList != null) && (deviceList.size() != 0)) {
                Iterator<ScannerInfo> it = deviceList.iterator();
                while(it.hasNext()) {
                    ScannerInfo scnInfo = it.next();
                    friendlyNameList.add(scnInfo.getFriendlyName());
                    if(scnInfo.isDefaultScanner()) {
                        defaultIndex = spinnerIndex;
                    }
                    ++spinnerIndex;
                }
            }
            else {
                updateStatus("Failed to get the list of supported scanner devices! Please close and restart the application.");
            }
            ArrayAdapter<String> spinnerAdapter = new ArrayAdapter<String>(ReserveActivity.this, android.R.layout.simple_spinner_item, friendlyNameList);
            spinnerAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
            spinnerScannerDevices.setAdapter(spinnerAdapter);
        }
    }

    private void setDecoders() {
        if (scanner != null) {
            try {
                ScannerConfig config = scanner.getConfig();
                // Set EAN8
                config.decoderParams.ean8.enabled = checkBoxEAN8.isChecked();
                // Set EAN13
                config.decoderParams.ean13.enabled = checkBoxEAN13.isChecked();
                // Set Code39
                config.decoderParams.code39.enabled= checkBoxCode39.isChecked();
                //Set Code128
                config.decoderParams.code128.enabled = checkBoxCode128.isChecked();
                scanner.setConfig(config);
            } catch (ScannerException e) {
                updateStatus(e.getMessage());
            }
        }
    }

    public void softScan(View view) {
        bSoftTriggerSelected = true;
        cancelRead();
    }

    private void cancelRead(){
        if (scanner != null) {
            if (scanner.isReadPending()) {
                try {
                    scanner.cancelRead();
                } catch (ScannerException e) {
                    updateStatus(e.getMessage());
                }
            }
        }
    }

    private void updateStatus(final String status){
        runOnUiThread(new Runnable() {
            @Override
            public void run() {
                textViewStatus.setText("" + status);
            }
        });
    }

    private void updateData(final String result){
        runOnUiThread(new Runnable() {
            @Override
            public void run() {
                if (result != null) {
                    if (editTxtCode128.hasFocus() && editTxtCode128.getText().toString() != "") {
                        Produit p = getProduitFromCode128(result);
                        if (p != null) {
                            editTxtCode128.setText(result);
                            editTxtNumRayon.setText("");
                            editTxtNumRayon.setVisibility(View.VISIBLE);
                            editTxtNumRayon.requestFocus();
                            if (p.getCommandable() != "X" && p.getNumero_de_rayon() != "null" && p.getNumero_de_rayon() != null  && p.getNumero_de_rayon() != "" ) {
                                txtAncienNumeroDeRayon.setText("Produit non commandable!\nRayon actuel: " + p.getNumero_de_rayon());
                            } else {
                                txtAncienNumeroDeRayon.setText("Produit non commandable!\nRayon actuel: N.C.");
                            }
                            if (p.getStock()<1) {
                                jouerSon();
                                if (p.getNumero_de_rayon() != "null" && p.getNumero_de_rayon() != null && p.getNumero_de_rayon() != "" && p.getNumero_de_rayon() != "0") {
                                    txtAncienNumeroDeRayon.setText("Attention, stock épuisé!\nRayon actuel: " + p.getNumero_de_rayon());
                                } else {
                                    txtAncienNumeroDeRayon.setText("Attention, stock épuisé!");
                                }
                            } else if (p.getNumero_de_rayon() != "null" && p.getNumero_de_rayon() != null && p.getNumero_de_rayon() != "" && p.getNumero_de_rayon() != "0") {
                                txtAncienNumeroDeRayon.setText("Rayon actuel: " + p.getNumero_de_rayon());
                            } else {
                                txtAncienNumeroDeRayon.setText("");
                            }
                            txtAncienNumeroDeRayon.setVisibility(View.VISIBLE);
                            ancienNumeroRayon = p.getNumero_de_rayon();
                            Toast.makeText(ReserveActivity.this, "Veuillez scanner un numéro de rayon", Toast.LENGTH_SHORT).show();
                        } else {
                            AlertDialog.Builder builder = new AlertDialog.Builder(ReserveActivity.this);
                                builder.setCancelable(true);
                                builder.setTitle("Produit inexistant");
                                String msg = "Le produit \""+result+"\" n'existe pas!";
                                builder.setMessage(msg);
                                builder.setPositiveButton("OK",
                                        new DialogInterface.OnClickListener() {
                                            @Override
                                            public void onClick(DialogInterface dialog, int which) {
                                                dialog.dismiss();
                                            }
                                        });
                                AlertDialog dialog = builder.create();
                            jouerSon();
                                dialog.show();
//                            Toast.makeText(ReserveActivity.this, "Le produit \""+result+"\" n'existe pas!", Toast.LENGTH_SHORT).show();
                            editTxtNumRayon.setText("");
                            editTxtNumRayon.setVisibility(View.INVISIBLE);
                            editTxtCode128.requestFocus();
                            txtAncienNumeroDeRayon.setText("");
                            txtAncienNumeroDeRayon.setVisibility(View.INVISIBLE);
                        }
                    } else if (editTxtNumRayon.hasFocus()) {
                        editTxtNumRayon.setText(result);
                        buttonModifier.callOnClick();
                    }
                }
            }
        });
    }

    //Permet de vérifier si le produit existe
    public Produit getProduitFromCode128(String code128){
        try {
            for (Produit p : listeAllProduits){
                if(p.getCode128().equals(code128)){
                    return p;
                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }
        return null;
    }

    @Override
    public void onCheckedChanged(CompoundButton arg0, boolean arg1) {
        bDecoderSettingsChanged = true;
        cancelRead();
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        getMenuInflater().inflate(R.menu.main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        int id = item.getItemId();
        if (id == R.id.action_settings) {
            return true;
        }
        return super.onOptionsItemSelected(item);
    }

    //BASE DE DONNES
    private class GetAllProduitsAsyncTask extends AsyncTask<String, String, String> {

        private final String BASE_URL = MainActivity.backOfficeURL;

        @Override
        protected void onPreExecute() {
            super.onPreExecute();
        }

        @Override
        protected String doInBackground(String... params) {
            HttpJsonParser httpJsonParser = new HttpJsonParser();
            JSONObject jsonObject = httpJsonParser.makeHttpRequest(
                    BASE_URL + "listeProduitsRayon.php", "GET", null);
            List<Produit> produitList = new ArrayList<>();
            try {
                int success = jsonObject.getInt("success");
                JSONArray produits;
                if (success == 1) {
                    produits = jsonObject.getJSONArray("data");
                    //Iterate through the response and populate produits list
                    for (int i = 0; i < produits.length(); i++) {
                        Produit p = new Produit();
                        JSONObject produit = produits.getJSONObject(i);
                        try {
                            p.setRef(produit.getString("reference"));
                            p.setColoris(produit.getString("coloris"));
                            p.setCode128(produit.getString("code_128"));
                            p.setNumero_de_rayon(produit.getString("numero_de_rayon"));
                            p.setCommandable(produit.getString("commandable"));
                            if (produit.getString("stock") == "null" || produit.getString("stock") == null) {
                                p.setStock(0);
                            } else {
                                p.setStock(Integer.parseInt(produit.getString("stock")));
                            }
                            produitList.add(p);
                        }catch (Exception e){
                            e.printStackTrace();
                        }
                    }
                    listeAllProduits = produitList;
                }
            } catch (JSONException e) {
                e.printStackTrace();
            }catch (Exception e){
                e.printStackTrace();
            }
            return null;
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
            editTxtCode128.setVisibility(View.VISIBLE);
            editTxtNumRayon.setVisibility(View.INVISIBLE);
            buttonModifier.setVisibility(View.INVISIBLE);
            txtChargement.setVisibility(View.INVISIBLE);
            // The application is in foreground
            if (emdkManager != null) {
                // Acquire the barcode manager resources
                initBarcodeManager();
                // Enumerate scanner devices
                enumerateScannerDevices();
                // Set selected scanner
                spinnerScannerDevices.setSelection(scannerIndex);
                // Initialize scanner
                initScanner();
            }
        }
    }

    public void modifierButton(View v){

        if (isOnline()){
            AlertDialog.Builder builder = new AlertDialog.Builder(ReserveActivity.this);
            if (ancienNumeroRayon != null && ancienNumeroRayon != "" && ancienNumeroRayon != "N.C." && ancienNumeroRayon != " " && ancienNumeroRayon != "0") {
                builder.setCancelable(true);
                builder.setTitle("Changement de rayon");
                String msg = "Souhaitez-vous changer le rayon du produit \""+editTxtCode128.getText().toString()+"\" de \""+ancienNumeroRayon+"\" vers \""+editTxtNumRayon.getText()+"\"?";
                builder.setMessage(msg);
                builder.setPositiveButton("Oui",
                        new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int which) {
                                //Modification du numéro de rayon
                                changerRayon();
                            }
                        });
                builder.setNegativeButton("Non",
                        new DialogInterface.OnClickListener() {
                            @Override
                            public void onClick(DialogInterface dialog, int which) {
                                //Modifier l'emplacement du fichier
                                editTxtCode128.setText("");
                                editTxtNumRayon.setText("");
                                txtAncienNumeroDeRayon.setText("");
                                editTxtCode128.requestFocus();
                                editTxtNumRayon.setVisibility(View.INVISIBLE);
                                buttonModifier.setVisibility(View.INVISIBLE);
                                dialog.dismiss();
                            }
                        });
                AlertDialog dialog = builder.create();
                dialog.show();
            } else {
                AlertDialog dialog = builder.create();
                //Modification du numéro de rayon
                changerRayon();

                //Modifier l'emplacement du fichier
                editTxtCode128.setText("");
                editTxtNumRayon.setText("");
                //editTxtCode128.setFocusable(false);
                //editTxtNumRayon.setFocusable(false);
                editTxtCode128.requestFocus();
                editTxtNumRayon.setVisibility(View.INVISIBLE);
                buttonModifier.setVisibility(View.INVISIBLE);

            }
        }else{
            Toast.makeText(getApplicationContext(), "Aucune connexion internet", Toast.LENGTH_SHORT).show();
        }
    }

    private void changerRayon() {
        if (editTxtCode128.getText().toString() != "" && editTxtNumRayon.getText().toString() != "") {
            HttpJsonParser httpJsonParser3 = new HttpJsonParser();
            Map<String, String> httpParams3 = new HashMap<>();
            httpParams3.put("code_128", editTxtCode128.getText().toString());
            httpParams3.put("numero_de_rayon", editTxtNumRayon.getText().toString());
            JSONObject jsonObject3 = httpJsonParser3.makeHttpRequest(
                    MainActivity.backOfficeURL + "updateProductRayon.php", "POST", httpParams3);
            try {
                int success = jsonObject3.getInt("success");
                if (success == 1) {
                    //Modifier l'emplacement du fichier
                    editTxtCode128.setText("");
                    editTxtNumRayon.setText("");
                    txtAncienNumeroDeRayon.setText("");
                    //editTxtCode128.setFocusable(false);
                    //editTxtNumRayon.setFocusable(false);
                    editTxtCode128.requestFocus();
                    Toast.makeText(getApplicationContext(), "Mise à jour du numéro de rayon!", Toast.LENGTH_SHORT).show();
                    editTxtNumRayon.setVisibility(View.INVISIBLE);
                    buttonModifier.setVisibility(View.INVISIBLE);
                    new GetAllProduitsAsyncTask().execute();
                } else {
                    editTxtCode128.setText("");
                    editTxtNumRayon.setText("");
                    txtAncienNumeroDeRayon.setText("");
                    //editTxtCode128.setFocusable(false);
                    //editTxtNumRayon.setFocusable(false);
                    editTxtCode128.requestFocus();
                    //AlertDialog dialog2 = builder.create();
                    //jouerSon();
                    Toast.makeText(getApplicationContext(), "Erreur mise à jour du numéro de rayon!", Toast.LENGTH_SHORT).show();
                    editTxtNumRayon.setVisibility(View.INVISIBLE);
                    buttonModifier.setVisibility(View.INVISIBLE);
                    //AlertDialog dialog2 = builder.create();
                    //builder.setCancelable(true);
                    //builder.setTitle("Erreur changement de rayon");
                    //String msg = "Souhaitez-vous recommencer ?";
                    //builder.setMessage(msg);
                    //builder.setPositiveButton("Oui",
                    //        new DialogInterface.OnClickListener() {
                    //            @Override
                    //            public void onClick(DialogInterface dialog, int which) {
                    //                changerRayon();
                    //                dialog2.dismiss();
                    //buttonModifier.callOnClick();
                    //            }
                    //        });
                    //builder.setNegativeButton("Non",
                    //        new DialogInterface.OnClickListener() {
                    //            @Override
                    //            public void onClick(DialogInterface dialog, int which) {
                    //                dialog2.dismiss();
                    //            }
                    //        });
                    //dialog.dismiss();
                    //dialog2.show();
                }
            } catch (JSONException e) {
                e.printStackTrace();
                editTxtCode128.setText("");
                editTxtNumRayon.setText("");
                //editTxtCode128.setFocusable(false);
                //editTxtNumRayon.setFocusable(false);
                editTxtCode128.requestFocus();
                //AlertDialog dialog2 = builder.create();
                //jouerSon();
                Toast.makeText(getApplicationContext(), "Erreur mise à jour du numéro de rayon!", Toast.LENGTH_SHORT).show();
                editTxtNumRayon.setVisibility(View.INVISIBLE);
                buttonModifier.setVisibility(View.INVISIBLE);
            /*AlertDialog.Builder builder2 = new AlertDialog.Builder(ReserveActivity.this);
            builder2.setCancelable(true);
            builder2.setTitle("Erreur !");
            String msg = "Erreur de mise à jour du numéro de rayon du produit "+editTxtCode128.getText().toString()+"!";
            builder2.setMessage(msg);
            builder2.setPositiveButton("OK",
                    new DialogInterface.OnClickListener() {
                        @Override
                        public void onClick(DialogInterface dialog, int which) {
                            dialog2.dismiss();
                        }
                    });
            dialog2.show();*/
            }
        } else if (editTxtNumRayon.getText().toString() != "") {
            Toast.makeText(getApplicationContext(), "Veuillez saisir un numéro de rayon!", Toast.LENGTH_SHORT).show();
        } else if (editTxtCode128.getText().toString() != "") {
            Toast.makeText(getApplicationContext(), "Veuillez saisir un code produit!", Toast.LENGTH_SHORT).show();
        }
    }

    void jouerSon() {
        mediaPlayer = new MediaPlayer();
        try {
            AssetFileDescriptor afd = null;
            afd = getResources().getAssets().openFd("notification.mp3");
            /*if (filename != "erreurProduit_v2.mp3") {
                mediaPlayer.setVolume(0.2f,0.2f);
            } else {*/
                mediaPlayer.setVolume(1.0f,1.0f);
            //}
            mediaPlayer.setDataSource(afd.getFileDescriptor(), afd.getStartOffset(), afd.getLength());
            mediaPlayer.prepareAsync();
        } catch (IllegalArgumentException e) {
            e.printStackTrace();
        } catch (IllegalStateException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
        //Lancer en mode asynchrone pour continuer en permanence
        mediaPlayer.setOnPreparedListener(mp -> mp.start());
        //Release après lecture
        mediaPlayer.setOnCompletionListener(mp -> {
            if (mp != null) {
                mp.release();
            }
        });
    }

}