package fr.itsee.season;

import android.os.Parcel;
import android.os.Parcelable;

public class Transporteur implements Parcelable, Comparable<Transporteur> {

    private String nom;
    private double prix, prixMax4, prixMax8, prixMax15, prixMax30;

    public Transporteur(){

    }

    public Transporteur(Transporteur t){
        this.nom = t.getNom();
        this.prix = t.getPrix();
        this.prixMax4 = t.getPrixMax4();
        this.prixMax8 = t.getPrixMax8();
        this.prixMax15 = t.getPrixMax15();
        this.prixMax30 = t.getPrixMax30();
    }


    protected Transporteur(Parcel in) {
        nom = in.readString();
        prix = in.readDouble();
        prixMax4 = in.readDouble();
        prixMax8 = in.readDouble();
        prixMax15 = in.readDouble();
        prixMax30 = in.readDouble();
    }

    public static final Creator<Transporteur> CREATOR = new Creator<Transporteur>() {
        @Override
        public Transporteur createFromParcel(Parcel in) {
            return new Transporteur(in);
        }

        @Override
        public Transporteur[] newArray(int size) {
            return new Transporteur[size];
        }
    };

    @Override
    public int compareTo(Transporteur transporteur) {
        return this.getNom().compareTo(transporteur.getNom());
    }

    public String getNom() {
        return nom;
    }

    public double getPrix() {
        return prix;
    }

    public double getPrixMax4() {
        return prixMax4;
    }
    public double getPrixMax8() {
        return prixMax8;
    }
    public double getPrixMax15() {
        return prixMax15;
    }
    public double getPrixMax30() {
        return prixMax30;
    }

    public void setNom(String nom) {
        this.nom = nom;
    }

    public void setPrix(double prix) {
        this.prix = prix;
    }
    public void setPrixMax4(double prixMax4) {
        this.prixMax4 = prixMax4;
    }
    public void setPrixMax8(double prixMax8) {
        this.prixMax8 = prixMax8;
    }
    public void setPrixMax15(double prixMax15) {
        this.prixMax15 = prixMax15;
    }
    public void setPrixMax30(double prixMax30) {
        this.prixMax30 = prixMax30;
    }

    @Override
    public String toString() {
        return "" + nom + ": " + prix + "€ HT";
    }

    @Override
    public int describeContents() {
        return 0;
    }

    @Override
    public void writeToParcel(Parcel parcel, int i) {
        parcel.writeString(nom);
        parcel.writeDouble(prix);
        parcel.writeDouble(prixMax4);
        parcel.writeDouble(prixMax8);
        parcel.writeDouble(prixMax15);
        parcel.writeDouble(prixMax30);
    }
}